//rutiny pro export do ruznych vystupnich souboru
const CWG_BUTTONS=4;     //pocet hodnot pro jedno CWG v poli v javascriptu
      CWG_PROPERTIES=8;
      IDX_NICK=0; IDX_NICKURL=1; IDX_DATESORT=2; IDX_DATETEXT=3; IDX_CWGID=4;
      IDX_IMG=5; IDX_CACHEID=6; IDX_CACHEURL=7;

procedure ExportSeznam(sFile:string); //exportuje obsah databaze jako prosty seznam
var s,sOut:string;
    tab:TSQLiteTable;
    i:integer;
begin
  DBOpen();
  sOut:='----- Katalog CWG -----';
  s:='SELECT Name,Version,Category,ID,Catalog FROM '+TABLE_CATALOG+' ORDER BY Name||" "||Version';
  tab:=CwgDB.GetTable(s,false);
  try
    i:=0;
    while not tab.eof do begin
      Int(i);
      s:=CRLF+IntToStr(i)+': '+UtfToAnsi(tab.FieldAsString(0))+', '+tab.FieldAsString(1)+', '
         +tab.FieldAsString(2)+', '+tab.FieldAsString(3)+', '+tab.FieldAsString(4);
      sOut:=sOut+s;
      tab.Next();
    end;
  finally
    tab.Free();
  end;

  sOut:=sOut+CRLF+CRLF+'----- Zskan CWG -----';
  s:='SELECT Name,Version,Category,ID FROM '+TABLE_FOUND+' ORDER BY Name||" "||Version';
  tab:=CwgDB.GetTable(s,false);
  try
    i:=0;
    while not tab.eof do begin
      Int(i);
      s:=CRLF+IntToStr(i)+': '+UtfToAnsi(tab.FieldAsString(0))+', '+tab.FieldAsString(1)+', '
         +tab.FieldAsString(2)+', '+tab.FieldAsString(3);
      sOut:=sOut+s;
      tab.Next();
    end;
  finally
    tab.Free();
  end;
  DBClose();
  StringToFile(sOut,sFile);
end;

function GetExportData(bSigitem,bCache:boolean;outcoding,sSort:string):TStringList;
var i:integer;
    s,scnt,ver,cache:string;
    tab:TSQLiteTable;
begin
  DBOpen(); //otevrit DB
  if(not FileExists(GetDBPathname())) then begin
    ShowMessage('ERR: Chyba otevreni databaze:'+CRLF+CRLF+GetDBPathname());
    GeoAbort();
  end;
  Result:=TStringList.Create();
  s:='SELECT my.Name, my.cnt, my.Version, my.CacheId '
    +' FROM '+TABLE_FOUND+' my '
    +' WHERE my.Category<>'''+AnsiToUtf(MY_CATEGORY)+'''';
  if(not bSigItem) then s:=s+CRLF+' and my.Category IN (''CWG'',''cwg'',''cle'',''ceg'',''swg'',''sle'',''seg'')';
  if(sSort='DATE') then s:=s+' order by my.DateFound'
  else if(sSort='CACHE') then s:=s+' order by my.CacheId'
  else s:=s+' order by my.Name';
  tab:=CwgDB.GetTable(s,false);
  i:=0;
  try
    while not tab.eof do begin
      if GeoBusyTest then Break;  //preruseno uzivatelem
      //Counter:=Counter+1;
      //GeoBusyProgress(Counter, max);
      // nactem CWG, prevedeme na pozadovane kodovani
      if(UpperCase(outcoding)='ASCII') then s:=UtfToAscii(tab.FieldAsString(0))
      else s:=UtfToCharset(tab.FieldAsString(0),outcoding);
           //s:=UtfToAnsi(tab.FieldAsString(0));
           //s:=(tab.FieldAsString(0));
      scnt:=tab.FieldAsString(1);
      ver:=tab.FieldAsString(2);
      cache:=Trim(tab.FieldAsString(3));
      if(ver>'1') then s:=s+' (verze '+ver+')';
      if(scnt>'1') then s:=s+' ['+scnt+' ks]';
      if(cache<>'') and (bCache) then s:=s+' {'+cache+'}';
      Result.Add(s);
      Inc(i);
      tab.next;                   // skok na dalsi
    end;
  finally
    if(tab<>nil) then tab.Free();
  end;
  DBClose();
end;

procedure ExportTxt(bSilent:boolean);
var a:TStringList;
    i,j,k,n:Integer;
    s,s1:string;
begin
  //OUTTXT_HORIZONTAL='1';        //1=tabulka je abecedne razena vodorovne, 0=svisle
  n:=StrToInt(OUTTXT_COLS);
  a:=GetExportData(false,true,OUTTXT_OUTCODING,'NAME'); //bez Sigitem, s ID kese
  s:='';
  if(OUTTXT_HORIZONTAL='1') then begin
    for i:=0 to a.Count-1 do begin
      for j:=0 to n-1 do begin
        if((i+j)<a.Count) then begin
          s:=s+IntToStr(i+j+1)+'. '+a[i+j];
          if(j<n-1) then s:=s+OUTTXT_SEPARATOR;
        end;
      end;
      s:=s+CRLF;
      i:=i+n-1;
    end;
  end else begin
    k:=(a.Count)/n;
    for i:=0 to k-1 do begin
      for j:=0 to n-1 do begin
        if((i+j*k)<a.Count-1) then begin
          s:=s+IntToStr(i+j*k+1)+'. '+a[i+j*k];
          if(j<n-1) then s:=s+OUTTXT_SEPARATOR;
        end;
      end;
      s:=s+CRLF;
    end;
  end;
  s1:=RelToAbsFilename(OUTTXT_FILE,GetCwgDir());
  StringToFile(s,s1);
  if(not bSilent) then ShowMessage('Seznam uloen do souboru:'+CRLF+CRLF+s1);
  if(a<>nil) then a.Free();
end;

procedure ExportGpxPoi(bSilent:boolean);
var a:TStringList;
    s,s1,sOut,ver:string;
    x,y:extended;
    i,j,n:Integer;
begin
  s1:=UpperCase(OUTPOI_SPLITCHARS);
  if(not RefPointGet(OUTPOI_REFPOINT,x,y)) then begin y:=14.0; x:=50.0; end;
  a:=GetExportData(false,false,OUTPOI_OUTCODING,'NAME'); //bez Sigitem, bez ID kese, v potrebnem kodovani
  n:=0;
  s:='';
  sOut:='';
  ver:=''; //prvni ulozeny znak
  for i:=0 to a.Count do begin
    if(i<a.Count) then begin
      j:=pos(UpperCase(copy(a[i],1,1)),s1);
      if(j>0) then begin
        s1:=ReplaceString(s1,copy(s1,j,1),''); //vymazeme znak, aby se na nem uz nedelil do dalsiho WPT
      end;
    end
    else j:=-1;
    if(i=a.Count) or (j>0) then begin
      if(s<>'') then begin //pridame zacatek a konec wpt a ulozime do Result
        sOut:=sOut
          + ReplaceString('<wpt lat="'+FormatFloat('0.0000000',x) //v souradnicich nahradime desetinnou carku teckou
            +'" lon="'+FormatFloat('0.0000000',y)+'">',',','.')+CRLF
          +'  <name>'+CDATA(OUTPOI_NAME+' '+copy(ver,1,1)+'-'+copy(ver,2,1))+'</name>'+CRLF
          +'  <cmt></cmt>'+CRLF
          +'  <desc><![CDATA['+s+']]></desc>'+CRLF
          +'</wpt>'+CRLF
        ver:='';
        s:='';
      end;
    end;
    if(i<a.Count) then begin
      //zapamatujeme si prvni a posledni pocatecni znak jmena CWG v tomto WPT
      ver:=copy(ver,1,1)+UpperCase(copy(a[i],1,1));
      //prkodujeme nebezpecne znaky a zapiseme do vystupu
      s:=s+IntToStr(i+1)+'. '+XMLEntityEncode(a[i])+'<br />'+CRLF;
    end;
  end;
  sOut:='<?xml version="1.0" encoding="utf-8" standalone="no" ?>'+CRLF
    +'<gpx '+CRLF
    +'  creator="'+GeoGet_Version+', CwgList2 '+GetCurrentPluginVersion()+'"'+CRLF
    +'  version="1.1"'+CRLF
    +'  xmlns="http://www.topografix.com/GPX/1/1"'+CRLF
    +'  xmlns:gpxx="http://www.garmin.com/xmlschemas/GpxExtensions/v3"'+CRLF
    +'  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"'+CRLF
    +'  xsi:schemaLocation="http://www.garmin.com/xmlschemas/GpxExtensions/v3 http://www.garmin.com/xmlschemas/GpxExtensions/v3/GpxExtensionsv3.xsd http://www.topografix.com/GPX/1/1 http://www.topografix.com/GPX/1/1/gpx.xsd">'
    +CRLF+CRLF+sOut+
{
      + ReplaceString('<wpt lat="'+FormatFloat('0.0000000',x) //v souradnicich nahradime desetinnou carku teckou
      +'" lon="'+FormatFloat('0.0000000',y)+'">',',','.')+CRLF
      +'  <name>'+CDATA(POI_NAME)+'</name>'+CRLF
      +'  <cmt></cmt>'+CRLF
      +'  <desc>'+CDATA(s)+'</desc>'+CRLF
      +'</wpt>'+CRLF
}
    +CRLF
    +'</gpx>'+CRLF;
  s1:=RelToAbsFilename(OUTPOI_FILE,GetCwgDir());
  StringToFile(sOut,s1);
  if(not bSilent) then ShowMessage('Seznam uloen do souboru:'+CRLF+CRLF+s1);
  if(a<>nil) then a.Free();
end;

//------------------------------------------------------------------------------
procedure ExportGpx(bSilent:boolean);
//var a:TStringList;
//    i:Integer;
begin
end;
//------------------------------------------------------------------------------
function ExportGgstatHeader:string; //vytvori hlavicku tabulky
begin
  Result:='';
end;
//------------------------------------------------------------------------------
function RemoveXChars(s:string):string;
begin   //odstranime nebezpecne znaky
  Result:=RegexReplace('(?is)[ ;:/|''+#$%@&*]',s,'',false);
end;
//------------------------------------------------------------------------------
function GetTableCfg(param,sTabGroup:string):string; //vraci ze stringu cast konfigurace platnou pro tuto tabulku
var sType,sTable,s:string;
begin
  //vstupni string se predpoklada ve tvaru 'GRP1:text|GRP2:text...' nebo 'text'
  //vraci se text platny pro vstupni skupinu
  sTable:=UpperCase(RemoveXChars(UtfToAscii(AnsiToUtf(sTabGroup))));
  while(param<>'') do begin
    Result:=Fetch(param,'|'); //podle jednotlivych tabulek
    sType:=Fetch(Result,':'); //jmeno skupiny
    if(Result='') then begin Result:=sType; sType:=''; end;
    sType:=UpperCase(RemoveXChars(UtfToAscii(AnsiToUtf(sType))));
    if(sTable=sType) or ((sTable='ALL') and (sType='')) then s:='' //nalezeno, dal nehledame
    else Result:='';
  end;
end;
//------------------------------------------------------------------------------
function MakeIdCard(IdTable:string;iNumCwg:Integer):string;
begin
  Result:='iCard_'+IdTable+'_';
  //-1 znamena, ze ne[pridavame cislo
  if(iNumCwg>-1) then Result:=Result+IntToStr(iNumCwg);
end;
//------------------------------------------------------------------------------
