//prace s API v 2 na gcm serveru

type TrGcm2Cmt=record
       sGcmId:string; //interni ID GCM  (muze byt prazdne?) - neni soucasti Comment
                      //na GCM, ale u me v databazi ano
       sGcmTags,      //puvodni, nedekodovana hodnota tagu
       sGcCode,sCmt,sCmtDate,sCmtName,sCmtGcCode:string;
     end;

var aGcm2CsvIdx:record
  id, name,version,cat_no,tags,date,pieces,year,comment,offers,wants,dont_want,
  nItems:integer;
  end;
  aCountry:TStringList;  //soubor se jmeny statu a jejich zkratkami

//deklarace funkce pro aktualizaci zobrazeni databaze (definice je v TabKatalog.pas)
procedure cbDatabaseOnChange(sender:TObject); forward;

function Gcm2GetDir:string;
begin Result:=GetCwgDir()+'gcm2/'; end;

function Gcm2GetIniPathName:string;
begin Result:=Gcm2GetDir()+'Gcm2Cmds.ini'; end;

function Gcm2GetIniAbbrPathName:string;
begin Result:=GetCwgDir()+'Gcm2CountryAbbr.ini'; end;

{$include Cwg2.Gcm2Token.pas}

function Gcm2JsonToTxt(sJson:string):string;
begin
  Result:=JSEntityDecode(sJson);
  Result:=ReplaceString(Result,',',','+CRLF);
  Result:=ReplaceString(Result,'{','{'+CRLF);
  Result:=ReplaceString(Result,']',']'+CRLF);
end;

//posle prikaz na server a ziska odpoved
function Gcm2SendCmd(sCmd,sParam:string):string;
var b:boolean;
    i,iErr:integer;
    sP:string;
begin
  Result:='';
  i:=0;
  iErr:=0;
  if(sGcm2Token='') then Gcm2ReadToken();
  if(sGcm2Token='') then Gcm2GetTokenFromGcm(GEOGET_OWNER,false);
  i:=0;
  while(i<2) do begin //opakujeme, pokud je problem s prihlasenim uzivatele
    //prazdny token, nahradime jej existujicim, aby byl pouzit ten po novem prihlaseni
    sP:=ReplaceString(sParam,'"token":""','"token":"'+sGcm2Token+'"');
    b:=HttpAsk('POST',sGcm2Url+sCmd,'text/json',sP,Result);
{$ifdef DEBUG_HELPER} LDH('Gcm2 - i='+IntToStr(i)); {$endif}
{$ifdef DEBUG_HELPER} LDH('Gcm2 - URL='+sGcm2Url+sCmd); {$endif}
{$ifdef DEBUG_HELPER} LDH('Gcm2 - param='+sP); {$endif}
//{$ifdef DEBUG_HELPER} LDH('Gcm2 - navrat='+Result); {$endif}
    if(not b) then begin
      ShowMessage('ERR: Chyba odeslani prikazu: '+sCmd);
      exit;
    end;
    iErr:=Gcm2NeedToken(Result);
{$ifdef DEBUG_HELPER} LDH('Gcm2 - iErr='+IntToStr(iErr)+' (po NeedToken)'); {$endif}
    if(iErr>1) then exit;
    //od 18.5.2017 pracuje server se jmenem uzivatele prevedenym na mala pismena!
    if(iErr=1) then Gcm2GetTokenFromGcm(GEOGET_OWNER,false);
    if(sGcm2Token='') then begin
      Result:='';
      ShowMessage('ERR: prihlaseni se nezdarilo, s GCM serverem nelze pracovat.');
      exit;
    end;
    if(iErr=0) then break; //podarilo se nacist na prvni pokus
    Inc(i);
  end;
//{$ifdef DEBUG_HELPER} LDH('Gcm2 - navratova hodnota='+Result); {$endif}
end;

//pocka na to, az bude predchozi prikaz (export nebo import dokoncen)
//pokud vrati false, bylo cekani preruseno uzivatelem = abort
function Gcm2WaitForExportComplete(sCmd,sId:string):boolean;
var sParam,sRes,sStat,sNum:string;
begin
  GeoBusyStart();
  GeoBusyCaption('Cekani na server: '+sCmd);
  //CwgForm.Visible:=false;
  Result:=true;
  sParam:='{"token":"", "exportIds": ['+sId+']}';
  while (true) do begin //nekonecna smycka
    if(GeoBusyTest()) then begin //preruseni uzivatelem
      Result:=false;
      break;
    end;
    sRes:=Gcm2SendCmd(sCmd,sParam);
    //zjistime vysledek
    Fetch(sRes,'"exportId":');
    Fetch(sRes,sId);
    Fetch(sRes,'"status"');
    Fetch(sRes,'"'); //zacatek textu statusu
    sStat:=Fetch(sRes,'"');
  {$ifdef DEBUG_HELPER} LDH('Gcm2 - cekani na export, status='+sStat); {$endif}
    //ziskame pocet CWG
    Fetch(sRes,'"pieces"'); Fetch(sRes,':');
    sNum:=Fetch(sRes,',');
    GeoBusyKind('Export CWG ze serveru: '+sNum);
  {$ifdef DEBUG_HELPER} LDH('Gcm2 - cekani na export, pocet zpracovanych='+sNum); {$endif}
    case sStat of
      'waiting',
      'processing': begin
                      Sleep(1000); //pockame sekundu
                      continue;
                    end;
      'done':       break;
      'error':      begin
                      ShowMessage('ERR: Chyba pri zpracovani exportu na serveru');
                      Result:=false;
                      break;
                    end;
    end;
  end;
  //CwgForm.Visible:=true;
end;

//pocka na to, az bude predchozi prikaz (export nebo import dokoncen)
//pokud vrati false, bylo cekani preruseno uzivatelem = abort
function Gcm2WaitForImportComplete(sCmd,sId:string):string;
var sParam,sRes,sStat:string;
begin
  GeoBusyStart();
  GeoBusyCaption('Cekani na server: '+sCmd);
  //CwgForm.Visible:=false;
  Result:='';
  sParam:='{"token":"", "importIds": ['+sId+'], "options":{"showImportResult":true}}';
  while (true) do begin //nekonecna smycka
    if(GeoBusyTest()) then begin //preruseni uzivatelem
      break;
    end;
    sRes:=Gcm2SendCmd(sCmd,sParam);
    //ulozit do souboru
    StringToFile(sRes,Gcm2GetDir()+'gcm-import.txt');
    //zjistime vysledek
    Fetch(sRes,'"importId":');
    Fetch(sRes,sId);
    Fetch(sRes,'"status"');
    Fetch(sRes,'"'); //zacatek textu statusu
    sStat:=Fetch(sRes,'"');
  {$ifdef DEBUG_HELPER} LDH('Gcm2 - cekani na import, status='+sStat); {$endif}
    GeoBusyKind('Import CWG na server: '+sStat);
    case sStat of
      'waiting',
      'processing': begin
                      Sleep(1000); //pockame sekundu
                      continue;
                    end;
      'done':       break;
      'error':      begin
                      ShowMessage('ERR: Chyba pri zpracovani importu na serveru');
                      break;
                    end;
    end;
  end;
  Result:=sRes;
  //CwgForm.Visible:=true;
end;

function Gcm2ParseComment(sComment:string):TrGcm2Cmt;
var s,sItem,s1:string;
begin
  //ziskame data z komentare, polozky jsou oddelene |
  //"hlavni" komentar nema identifikaci a v tom pripade je prvni
  //databazovy string obsahuje i sGcmId a sGcmTags, string z GCM jej neobsahuje
  s:=sComment;
  while(s<>'') do begin
    s1:=Fetch(s,'|');
    sItem:=Fetch(s1,':');
    if(sItem='CACHE_ID') then Result.sGcCode:=s1
    else if(sItem='CMT_CACHEID') then Result.sCmtGcCode:=s1
    else if(sItem='CMT_NAME') then Result.sCmtName:=s1
    else if(sItem='CMT_DATE') then Result.sCmtDate:=s1
    else if(sItem='GCM_ID') then Result.sGcmId:=s1
    else if(sItem='GCM_TAGS') then Result.sGcmTags:=s1
    else Result.sCmt:=sItem
    ;
  end;
end;

function Gcm2ComposeComment(rCmt:TrGcm2Cmt; bForGcm:boolean):string;
begin
  //sestavi string pro databazi (obsahuje i ID) nebo pro odeslani do GCM (neobsahuje ID)
  //oddelovacem polozek je |
  Result:='';
  if(rCmt.sCmt<>'') then Result:=rCmt.sCmt+CRLF;
  if(rCmt.sGcmId<>'') and (not bForGcm) then Result:=Result+'GCM_ID: '+rCmt.sGcmId+CRLF;
  if(rCmt.sGcCode<>'') then Result:=Result+'CACHE_ID: '+rCmt.sGcCode+CRLF;
  if(rCmt.sCmtGcCode<>'') then Result:=Result+'CMT_CACHEID: '+rCmt.sCmtGcCode+CRLF;
  if(rCmt.sCmtName<>'') then Result:=Result+'CMT_NAME: '+rCmt.sCmtName+CRLF;
  if(rCmt.sCmtDate<>'') then Result:=Result+'CMT_DATE: '+rCmt.sCmtDate+CRLF;
  if(rCmt.sGcmTags<>'') and (not bForGcm) then Result:=Result+'GCM_TAGS: '+rCmt.sGcmTags+CRLF;
  Result:=ReplaceString(Trim(Result),CRLF,' | ');
end;

function Gcm2ParseCsvStruct(sRow:string):boolean; //nacte indexy jednotlivych polozek, vraci priznak uspesnosti
var sItem:string;
    i:integer;
begin
  Result:=false; //predpokladame chybu
  Fetch(sRow,'"exportData":"');
  if(sRow='') then begin
    ShowMessage('ERR: chybny format nactenych dat, nenalezena struktura CSV souboru.');
    exit;
  end;
  //inicializace
  with aGcm2CsvIdx do begin
    id:=-1; name:=-1; version:=-1; cat_no:=-1; tags:=-1; date:=-1; pieces:=-1;
    year:=-1; comment:=-1; offers:=-1; wants:=-1; dont_want:=-1;
    i:=0;
    while(sRow<>'') do begin
      sItem:=Fetch(sRow,';');
      case (sItem) of
      'id': id:=i;
      'name': name:=i;
      'version': version:=i;
      'cat_no': cat_no:=i;
      'tags': tags:=i;
      'date': date:=i;
      'pieces': pieces:=i;
      'year': year:=i;
      'comment': comment:=i;
      'offers': offers:=i;
      'wants': wants:=i;
      'dont_want': dont_want:=i;
      else begin
          ShowMessage('ERR: v CSV strukture je neocekavana polozka: '+sItem);
          exit;
        end;
      end;
      Inc(i);
    end;
    nItems:=i;
    sItem:='';
    if(id=-1) then sItem:=sItem+'id'+CRLF;
    if(name=-1) then sItem:=sItem+'name'+CRLF;
    if(version=-1) then sItem:=sItem+'version'+CRLF;
    if(cat_no=-1) then sItem:=sItem+'cat_no'+CRLF;
    if(tags=-1) then sItem:=sItem+'tags'+CRLF;
    if(date=-1) then sItem:=sItem+'date'+CRLF;
    if(pieces=-1) then sItem:=sItem+'pieces'+CRLF;
    if(year=-1) then sItem:=sItem+'year'+CRLF;
    if(comment=-1) then sItem:=sItem+'comment'+CRLF;
    if(offers=-1) then sItem:=sItem+'offers'+CRLF;
    if(wants=-1) then sItem:=sItem+'wants'+CRLF;
    if(dont_want=-1) then sItem:=sItem+'dont_want'+CRLF;
    if(sItem<>'') then begin
      ShowMessage('ERR: v CSV strukture chybi povinna polozka:'+CRLF
        +ReplaceString(Trim(sItem),CRLF,', '));
      exit;
    end;
{$ifdef DEBUG_HELPER} LDH('INFO: indexy struktury CSV souboru (pocet='+IntToStr(i)+'):'+CRLF
  +'id='+IntToStr(id)+', name='+IntToStr(name)+', version='+IntToStr(version)
  +', cat_no='+IntToStr(cat_no)+', tags='+IntToStr(tags)+', date='+IntToStr(date)
  +', pieces='+IntToStr(pieces)+', year='+IntToStr(year)+', comment='+IntToStr(comment)
  +', offers='+IntToStr(offers)+', wants='+IntToStr(wants)+', dont_want='+IntToStr(dont_want)
  ); {$endif}
  end;
  Result:=true; //bez chyby
end;

function Gcm2AbbrToCountry(sAbbr:string):string;
var i:integer;
begin
  Result:='???';
  for i:=0 to aCountry.Count-1 do begin
    if(aCountry.ValueFromIndex[i]=sAbbr) then begin
      Result:=aCountry.Names[i];
      break;
    end;
  end;
  if(Result='???') then begin
{$ifdef DEBUG_HELPER} LDHE('ERR: Abbr->Country: neznama zkratka='+sAbbr); {$endif}
    if(GEOGET_OWNER<>'gordici') then ShowMessage('ERR: Abbr->Country: neznama zkratka='+sAbbr);
  end;
end;

function Gcm2CountryToAbbr(sCountry:string):string; //prevede text statu na zkratku
begin
  //zajimave je, ze v seznamu statu ma gcm casto jazyky misto statu, nekdy je cesky, jindy anglicky
  Result:=aCountry.Values[sCountry];
  if(Result='') then begin
{$ifdef DEBUG_HELPER} LDHE('ERR: Country->Abbr: neznamy stat='+sCountry); {$endif}
    if(GEOGET_OWNER<>'gordici') then ShowMessage('ERR: Country->Abbr: neznamy stat='+sCountry);
    Result:=sCountry;
  end;
end;

//prida nebo aktualizuje zaznam pro zadane CWG
function Gcm2AddToDb(sId,sVer,sName,sCategory,sDate,sCount,sCountry,sYear,sImg:string;
  rCmt:TrGcm2Cmt;bAdd:boolean):boolean;
var iFlag:integer;
    s{,sCatalog}:string;
begin
  Result:=true;
  iFlag:=2; //datum nezname nebo nebylo nalezeno v kesi
  if(sDate<>'') and (rCmt.sGcCode<>'') then begin
    GEOGET_DB.AddParamText(':id',rCmt.sGcCode);
    s:=GEOGET_DB.GetTableString('SELECT dtfound FROM geocache WHERE id=:id');
    if(s=sDate) then iFlag:=0 //shodny s datem nalezu kese
    else iFlag:=1;            //ruzny od data nalezu kese
  end;
  CwgDB.AddParamText(':nameUp',AnsiToUpAscii(sName)+VerToSuffix(StrToInt(sVer)));
  CwgDB.AddParamText(':name',AnsiToUtf(sName));
  CwgDB.AddParamInt(':id',StrToInt(sId));
  CwgDB.AddParamText(':cat',AnsiToUtf(sCategory));
  CwgDB.AddParamInt(':ver',StrToInt(sVer));
  CwgDB.AddParamText(':dat',sDate);
  CwgDB.AddParamInt(':isdat',iFlag);
  CwgDB.AddParamInt(':cnt',StrToInt(sCount));
  //teoreticky tam muze byt jakykoli text, proto prevod na UTF
  CwgDB.AddParamText(':cacheId',AnsiToUtf(rCmt.sGcCode));
  CwgDB.AddParamText(':img',sImg);
  CwgDB.AddParamText(':guid','');
  CwgDB.AddParamText(':group',AnsiToUtf(''));
  CwgDB.AddParamText(':comName',AnsiToUtf(rCmt.sCmtName));
  CwgDB.AddParamText(':comDate',AnsiToUtf(rCmt.sCmtDate));
  CwgDB.AddParamText(':comId',AnsiToUtf(rCmt.sCmtGcCode));
  CwgDB.AddParamText(':comImg',AnsiToUtf(''));
  CwgDB.AddParamText(':gcmData',AnsiToUtf(Gcm2ComposeComment(rCmt,false)));
  CwgDB.AddParamText(':svetgcData','');
  CwgDB.AddParamText(':country',AnsiToUtf(sCountry));
  {
  //polozky do katalogu, ne do nalezenych
  //CwgDB.AddParamText(':comment',AnsiToUtf(rCmt.sCmt));
  //CwgDB.AddParamText(':zarazeni',sYear);
  //pokud je urcena kategorie, jedna se o katalogove CWG
  //if(sCategory<>'???') then sCatalog:='G' else sCatalog:='C';
  //CwgDB.AddParamText(':catalog',sCatalog);
  //CwgDB.ExecSQL('INSERT INTO '+TABLE_CATALOG
  //  +' (NameUpAscii,    Name,  Id,  Category, Version, DateFound, Cnt,  CacheId,  Img,  GUID,  CommentName, CommentCacheId, CommentDate, CommentImg, TabGroup, IsCacheFound, GcmData, SvetGcData, Country, Comment, Catalog, Zarazeno) '
  //  +' VALUES (:nameUp, :name, :id, :cat,     :ver,    :dat,     :cnt, :cacheId, :img, :guid, :comName,    :comId,         :comDate,    :comImg,    :group,    :isdat,      :gcmData, :svetgcData,:country, :comment, :catalog, :zar)'
  //  );
  }
  if(bAdd) then
  CwgDB.ExecSQL('INSERT INTO '+TABLE_FOUND
    +' (NameUpAscii,    Name,  Id,  Category, Version, DateFound, Cnt,  CacheId,  Img,'
    +   '  GUID,  CommentName, CommentCacheId, CommentDate, CommentImg, TabGroup, '
    +   '  IsCacheFound, GcmData, SvetGcData, Country) '
    +' VALUES (:nameUp, :name, :id, :cat,     :ver,    :dat,     :cnt, :cacheId, :img,'
    +   ' :guid, :comName,    :comId,         :comDate,    :comImg,    :group,'
    +   ' :isdat,      :gcmData, :svetgcData, :country)'
    {
    +' VALUES ("'+AnsiToUpAscii(sName)+VerToSuffix(StrToInt(sVer))+'"' //:nameUp
    +', "'+AnsiToUtf(sName)+'"' //:name
    +', "'+sId+'"' // :id
    +', "'+sCategory+'"' // :cat
    +', "'+sVer+'"' // :ver
    +', "'+sDate+'"' // :dat
    +', '+sCount // :cnt
    +', "'+AnsiToUtf(rCmt.sGcCode)+'"' // :cacheId
    +', ""' // :img
    +', ""' // :guid
    +', "'+AnsiToUtf(rCmt.sCmtName)+'"' // :comName
    +', "'+AnsiToUtf(rCmt.sCmtGcCode)+'"' // :comId
    +', "'+AnsiToUtf(rCmt.sCmtDate)+'"' // :comDate
    +', ""' // :comImg
    +', ""' // :group
    +', '+IntToStr(iFlag) // :isdat
    +', "'+AnsiToUtf(Gcm2ComposeComment(rCmt,false))+'"' // :gcmData
    +', "'++'"' // :svetgcData
    +', "'+AnsiToUtf(sCountry)+'"' // :country
    +')'
    }
    )
  else //aktualizovat polozky, ktere jsou z GCM - Img, CommentImg, GUID, TabGroup, SvetGcData si nevsima
    //asi by bylo dobre Img kontrolovat, zda existuje v databazi, aby se neprepisovalo
    if(sImg<>'') then
      CwgDB.ExecSQL('UPDATE '+TABLE_FOUND+' SET '
      +' DateFound=:dat, Cnt=:cnt, CacheId=:cacheId,'
      +'   CommentName=:comName, CommentCacheId=:comId, CommentDate=:comDate,'
      +'   IsCacheFound=:isdat,GcmData=:gcmData,Img=:img'
      +' WHERE Id=:id AND Name=:name AND Category=:cat')
    else
      CwgDB.ExecSQL('UPDATE '+TABLE_FOUND+' SET '
      +' DateFound=:dat, Cnt=:cnt, CacheId=:cacheId,'
      +'   CommentName=:comName, CommentCacheId=:comId, CommentDate=:comDate,'
      +'   IsCacheFound=:isdat,GcmData=:gcmData'
      +' WHERE Id=:id AND Name=:name AND Category=:cat')
  ;
end;

function Gcm2GetXmlItem(sElem:string; var sCwg:string):string;
var s:string;
begin
  Result:='';
  s:=Fetch(sCwg,'<'+sElem+'>');
  if(sCwg='') then sCwg:=s
  else Result:=Fetch(sCwg,'</'+sElem+'>');
end;

procedure Gcm2ParseXmlData(sCwg:string); //parsuje a ulozi data jednoho CWG
var sId,sIdVer,sIdGcm,sVer,sCategory,sName,sTags,sDate,sCount,sYear,sComment,sWants,
      sImg,sType,sOffers,sDontWant,sCountry,sOrigin:string;
    s,sTagsXml,sTag1,sTagValue,sTagCategory,sTagId,sCollectionXml:string;
    rCmt,rCmt2:TrGcm2Cmt;
    tab:TSQLiteTable;
begin
  Fetch(sCwg,'<cwg id="');
  sIdGcm:=Fetch(sCwg,'"');
  if(sIdGcm='') then exit;                   //asi konec souboru, neni tu CWG
  sId:=Gcm2GetXmlItem('cat_no',sCwg);
  sName:=Gcm2GetXmlItem('name',sCwg);
  sTagsXml:=Gcm2GetXmlItem('tags',sCwg);
  sVer:=Gcm2GetXmlItem('version',sCwg);
  sImg:=Gcm2GetXmlItem('image',sCwg);
{$ifdef DEBUG_HELPER} LDH('INFO: IMG='+sImg); {$endif}

  sCollectionXml:=Gcm2GetXmlItem('collection',sCwg);
  //u katalogovych vymazeme obrazek, protoze je v oficialnim katalogu
  if(sId<>'') and (GCM_SAVE_IMG_FOR_CATALOG<>'1') then sImg:='';
  if(sId<>'') then begin     //parsujeme katalogove cislo na ID a kategorii
    sCategory:=RegexSubstitute('(?i)([a-z]+)[0-9]+',sId,'$1');
    sIdVer:=RegexSubstitute('(?i)-([0-9]+)',sId,'$1');
    sId:=RegexSubstitute('(?i)[a-z]+([0-9]+)',sId,'$1');
    if(sIdVer='') then sIdVer:='1';
{$ifdef DEBUG_HELPER} if(sIdVer<>sVer) then LDHW('WARN: nesoulad mezi verzi a cislam za pomckou v ID: (sVer='+sVer+', sIdVer='+sIdVer+')'); {$endif}
  end
  else begin //nasavime ID, verzi a kategorii
{$ifdef DEBUG_HELPER} LDH('INFO: CWG mimo katalog'); {$endif}
    sCategory:='';
    sId:=IntToStr(UpdateLastId(true));
  end;
  //pokud je v img zadni strana (tzn ve jmene obrazku neni GCM_ID ani ID),
  //nebudeme pouzivat
  if(Pos(sIdGcm,sImg)<1) and (Pos(sId,sImg)<1) then sImg:='';
  //parsujeme vsechny tagy
  while(sTagsXml<>'') do begin
    sTag1:=Gcm2GetXmlItem('tag',sTagsXml);
    if(sTag1='') then break;
    sTagValue:=Gcm2GetXmlItem('name',sTag1);
    sTagCategory:=Gcm2GetXmlItem('category',sTag1);
    sTagId:=Gcm2GetXmlItem('id',sTagCategory);
    case sTagId of
    'country': begin sTags:=sTags+'country:'+sTagValue; sCountry:=sTagValue; end;
    'origin':  begin sTags:=sTags+'origin:'+sTagValue; sOrigin:=sTagValue; end;
    'type':    begin sTags:=sTags+'type:'+sTagValue; sType:=sTagValue; end;
    else begin
{$ifdef DEBUG_HELPER} LDHW('WARN: neznamy typ tagu: '+sTagId+'='+sTagValue); {$endif}
      end;
    end;
  end;
  if(sCategory='') then begin       //a nastavime kategorii, pokud je to potreba
    //tady muze byt xWG, SQ, MWG (viz nacteni seznamu kategorii, hodnoty pro "type")
    case sType of
    'SQ','MWG': sCategory:=sType;
    'xWG':      sCategory:='CWG';
    else begin
      ShowMessage('ERR: neznamy typ: "'+sType+'" (pouzito jako nova hodnota pro Category)');
      sCategory:=sType;
      end;
    end;
  end;
  //sestavime sTags, jako by to bylo z CSV souboru
  sTags:=ReplaceString(Trim(sTags),CRLF,',');
  //parsujeme vsechny zaznamy z kolekce
  while(sCollectionXml<>'') do begin
    sTag1:=Gcm2GetXmlItem('entry',sCollectionXml);
    if(sTag1='') then break;
    sDate:=Gcm2GetXmlItem('date',sTag1);
    sYear:=Gcm2GetXmlItem('year',sTag1);
    sComment:=Gcm2GetXmlItem('comment',sTag1);
    sCount:=Gcm2GetXmlItem('pieces',sTag1);
  end;
  if(sCount='') then exit; //ignorujeme CWG, ktera nemaji zadany pocet (jsou wanted nebo no_wanted)
  if(StrToInt(sCount)<1) then begin
{$ifdef DEBUG_HELPER} LDH('INFO: ID(gcm)='+sIdGcm+' - ignoruji, pocet kusu='+sCount); {$endif}
    exit;
  end;

  rCmt:=Gcm2ParseComment(sComment);
  rCmt.sGcmId:=sIdGcm;
  rCmt.sGcmTags:=sTags;
{$ifdef DEBUG_HELPER} LDH('parsovano: Id(gcm)='+sIdGcm+', sId='+sId
  +', sCat='+sCategory+', sVer='+sVer+', name='+sName+', sCountry='+sCountry
  +', sCount='+sCount+', sDate='+sDate+', sYear='+sYear+', sGcCode='+rCmt.sGcCode
  +', sCmt='+rCmt.sCmt+', sCmtDate='+rCmt.sCmtDate+', sCmtName='+rCmt.sCmtName
  +', sCmtGcCode='+rCmt.sCmtGcCode
  +', sImg='+sImg
  +', offers='+sOffers+', wants='+sWants+', dont_want='+sDontWant
  ); {$endif}
  //kontrola existujicich nekatalogovych CWG - pokud je nekatalogove, zkusime
  //v GcmDatech najit prislusne ID_GCM a z toho pripadne nekatalogove (zaporne)
  //ID, abychom mohli prepsat hodnoty z gcm do databaze
  if(StrToInt(sId)<0) then begin
    s:='SELECT Id, GcmData FROM '+TABLE_FOUND+' WHERE GcmData LIKE ''%GCM_ID: '+sIdGcm+'%''';
    tab:=CwgDb.GetTable(s,false);
    try
      while not tab.eof do begin
        //zkontrolujeme, zda je to opravdu spravne ID_GCM a ne jen shodny zacatek
        rCmt2:=Gcm2ParseComment(tab.FieldAsString(1));
        if(rCmt2.sGcmId=sIdGcm) then begin
          sId:=tab.FieldAsString(0);
{$ifdef DEBUG_HELPER} LDH('INFO:   ID_GCM='+sIdGcm+' >>> ID='+sId); {$endif}
          break;
        end;
        tab.Next();
      end;
    finally
      tab.Free();
    end;
  end;
  //uz je mezi vlastnenymi?
  CwgDb.AddParamText(':id',sId);
  CwgDb.AddParamText(':name',AnsiToUtf(sName));
  CwgDb.AddParamText(':cat',AnsiToUtf(sCategory));
  s:=CwgDb.GetTableString('SELECT Cnt FROM '+TABLE_FOUND
    +' WHERE Id=:id AND Name=:name AND Category=:cat');
  //doplnit nebo aktualizovat CWG v databazi
  Gcm2AddToDb(sId,sVer,sName,sCategory,sDate,sCount,sCountry,sYear,sImg,rCmt,(s=''));
end;

procedure Gcm2ParseCsvData(sRow:string); //parsuje a ulozi data jednoho CWG
var idx:integer;
    sItem,s,s1:string;
    sId,sIdVer,sIdGcm,sVer,sCategory,sName,sTags,sDate,sCount,sYear,sComment,sWants,
      sType,sOffers,sDontWant,sCountry:string;
    rCmt,rCmt2:TrGcm2Cmt;
    tab:TSQLiteTable;
begin
  idx:=0;
{$ifdef DEBUG_HELPER} LDH('sRow : '+sRow); {$endif}
  while(sRow<>'') do begin
    sItem:=Fetch(sRow,';');
//{$ifdef DEBUG_HELPER} LDH('sRow   (po): '+sRow); {$endif}
    if(idx=aGcm2CsvIdx.id) then sIdGcm:=sItem
    else if(idx=aGcm2CsvIdx.name) then sName:=sItem
    else if(idx=aGcm2CsvIdx.version) then sVer:=sItem
    else if(idx=aGcm2CsvIdx.cat_no) then sId:=sItem
    else if(idx=aGcm2CsvIdx.tags) then sTags:=sItem
    else if(idx=aGcm2CsvIdx.date) then sDate:=sItem
    else if(idx=aGcm2CsvIdx.pieces) then sCount:=sItem
    else if(idx=aGcm2CsvIdx.year) then sYear:=sItem
    else if(idx=aGcm2CsvIdx.comment) then sComment:=sItem
    else if(idx=aGcm2CsvIdx.offers) then sOffers:=sItem
    else if(idx=aGcm2CsvIdx.wants) then sWants:=sItem
    else if(idx=aGcm2CsvIdx.dont_want) then sDontWant:=sItem
    ;
    Inc(idx);
  end;
  if(idx<>aGcm2CsvIdx.nItems) then begin
{$ifdef DEBUG_HELPER} LDHE('ERR: ID(gcm)='+sIdGcm+' - chybny pocet polozek ('
      +IntToStr(idx)+' misto '+IntToStr(aGcm2CsvIdx.nItems)); {$endif}
    if(GEOGET_OWNER<>'gordici') then
      ShowMessage('ERR: ID(gcm)='+sIdGcm+' - chybny pocet polozek ('
        +IntToStr(idx)+' misto '+IntToStr(aGcm2CsvIdx.nItems));
    exit;
  end;
  //ignorujeme polozky, ktere nemaji pocet 1 a vice, asi jsou to wants, dont_want
  if(StrToInt(sCount)<1) then begin
{$ifdef DEBUG_HELPER} LDH('INFO: ID(gcm)='+sIdGcm+' - ignoruji, pocet kusu='+sCount); {$endif}
    exit;
  end;
  //pokud neni katalogove ID, zjistime nove nekatalogove pro pridani
  if(sId='') then begin
{$ifdef DEBUG_HELPER} LDH('INFO: ----------- prazdne ID pro ID_GCM='+sIdGcm); {$endif}
    sCategory:='';
    sId:=IntToStr(UpdateLastId(true));
  end
  else begin
    //z katalogoveho ID ziskame kategorii a ID (verze tam neni, cislo za pomlckou
    //je asi nejak interni poradi zaraceni do katalogu...)
    sCategory:=RegexSubstitute('(?i)([a-z]+)[0-9]+',sId,'$1');
    sIdVer:=RegexSubstitute('(?i)-([0-9]+)',sId,'$1');
    sId:=RegexSubstitute('(?i)[a-z]+([0-9]+)',sId,'$1');
    if(sIdVer='') then sIdVer:='1';
{$ifdef DEBUG_HELPER} if(sIdVer<>sVer) then LDHW('WARN: nesoulad mezi verzi a cislam za pomckou v ID: (sVer='+sVer+', sIdVer='+sIdVer+')'); {$endif}
  end;
  //ziskame typ, pro pripad, ze neni kategorie, tak abychom nastavili CWG nebo SQ
//{$ifdef DEBUG_HELPER} LDH('sTag='+sTags); {$endif}
  s1:=sTags;
  Fetch(s1,'type:');
//{$ifdef DEBUG_HELPER} LDH('s1='+s1); {$endif}
  if(Pos(',',s1)>0) then sType:=Fetch(s1,',')
  else sType:=s1;
  if(sCategory='') then begin       //a nastavime kategorii, pokud je to potreba
    //tady muze byt xWG, SQ, MWG (viz nacteni seznamu kategorii, hodnoty pro "type")
    case sType of
    'SQ','MWG': sCategory:=sType;
    'xWG':      sCategory:='CWG';
    else begin
      ShowMessage('ERR: neznamy typ: '+sType+' (pouzito jako nova hodnota pro Category)');
      sCategory:=sType;
      end;
    end;
  end;
//{$ifdef DEBUG_HELPER} LDH('sCategory='+sCategory); {$endif}
  //ziskame stat z tagu (je oddelen carkou nebo je na konci stringu
  s1:=sTags;
  Fetch(s1,'country:');
  if(Pos(',',s1)>0) then s:=Fetch(s1,',')
  else s:=s1;
  sCountry:=Gcm2CountryToAbbr(s);
  sDate:=ReplaceString(sDate,'-',''); //prevedeme datum ziskani na spravny format
  rCmt:=Gcm2ParseComment(sComment);
  rCmt.sGcmId:=sIdGcm;
  rCmt.sGcmTags:=sTags;
{$ifdef DEBUG_HELPER} LDH('parsovano: Id(gcm)='+sIdGcm+', sId='+sId
  +', sCat='+sCategory+', sVer='+sVer+', name='+sName+', sCountry='+sCountry
  +', sCount='+sCount+', sDate='+sDate+', sYear='+sYear+', sGcCode='+rCmt.sGcCode
  +', sCmt='+rCmt.sCmt+', sCmtDate='+rCmt.sCmtDate+', sCmtName='+rCmt.sCmtName
  +', sCmtGcCode='+rCmt.sCmtGcCode
  +', offers='+sOffers+', wants='+sWants+', dont_want='+sDontWant
  ); {$endif}
  //kontrola existujicich nekatalogovych CWG - pokud je nekatalogove, zkusime
  //v GcmDatech najit prislusne ID_GCM a z toho pripadne nekatalogove (zaporne)
  //ID, abychom mohli prepsat hodnoty z gcm do databaze
  if(StrToInt(sId)<0) then begin
    s:='SELECT Id, GcmData FROM '+TABLE_FOUND+' WHERE GcmData LIKE ''%GCM_ID: '+sIdGcm+'%''';
    tab:=CwgDb.GetTable(s,false);
    try
      while not tab.eof do begin
        //zkontrolujeme, zda je to opravdu spravne ID_GCM a ne jen shodny zacatek
        rCmt2:=Gcm2ParseComment(tab.FieldAsString(1));
        if(rCmt2.sGcmId=sIdGcm) then begin
          sId:=tab.FieldAsString(0);
{$ifdef DEBUG_HELPER} LDH('INFO:   ID_GCM='+sIdGcm+' >>> ID='+sId); {$endif}
          break;
        end;
        tab.Next();
      end;
    finally
      tab.Free();
    end;
  end;
  //uz je mezi vlastnenymi?
  CwgDb.AddParamText(':id',sId);
  CwgDb.AddParamText(':name',AnsiToUtf(sName));
  CwgDb.AddParamText(':cat',AnsiToUtf(sCategory));
  s:=CwgDb.GetTableString('SELECT Cnt FROM '+TABLE_FOUND
    +' WHERE Id=:id AND Name=:name AND Category=:cat');
  //doplnit nebo aktualizovat CWG v databazi
  Gcm2AddToDb(sId,sVer,sName,sCategory,sDate,sCount,sCountry,sYear,'',rCmt,(s=''));
end;

function Gcm2Export:string;       //export kolekce (sbirky) z gcm do me databaze
var sCmd,sParam,sRes,sId,sFormat:string;
    n:integer;
    nBytes:integer;
begin
  //CwgForm.Hide();
  GeoBusyStart();
  GeoBusyCaption('Parsovani a import kolekce z GCM');
  Result:='';
  //zavolame pripravu dat
  sCmd:='collection/export';
  sFormat:='fullcsv';
  sFormat:='fullxml';
  //sFormat:='svetgc';
  //sFormat:='csv';
  //sFormat:='html';
  if(GEOGET_OWNER='gordici') then begin
    sRes:=FileToString(Gcm2GetDir()+'gcm-export_'+sFormat+'_GeoBlackbirds.txt');
  end
  else begin
    GeoBusyKind('Import dat ze serveru ...');
    Gcm2ReadToken();
    sParam:='{"token":"", "options": {"format":"'+sFormat+'"}}';
    sRes:=Gcm2SendCmd(sCmd,sParam);
    Fetch(sRes,'"exportId":');    //z odpovedi ziskame ID rozpracovaneho pozadavku
    sId:=Fetch(sRes,'}');
  {$ifdef DEBUG_HELPER} LDH('Gcm2 - sId='+sId); {$endif}
    if(sId='') then exit; ///divne, k tomu by dojit nemelo
    //pockame na pripravena data
    if(Gcm2WaitForExportComplete('export/query',sId)=false) then exit;
    //pripravena data stahneme a ulozime do souboru
    sRes:=Gcm2SendCmd('export/get','{"token":"", "exportId":'+sId+'}');
    sRes:=JSEntityDecode(sRes);
    StringToFile(sRes,Gcm2GetDir()+'gcm-export_'+sFormat+'.txt');
  end;
  GeoBusyKind('Uprava: LF->CRLF ...');
  sRes:=UtfToAnsi(ReplaceString(sRes,Chr($0A),CRLF));//pokud je treba, prevedeme na CRLF a ANSI
  //ziskame strukturu dat
  sParam:=Fetch(sRes,CRLF);
  //otevrit databazi a zahajit transakci
  DBOpen();
  CwgDB.Start('GCM',''); //zahajime transakci
  //dekodujeme data a ulozime je do databaze
  n:=0;
  //pripravime soubor se zkratkami statu
  aCountry:=TStringList.Create();
  try
    if(not FileExists(Gcm2GetIniAbbrPathName())) then
      ShowMessage('ERR: nenalezen soubor '+Gcm2GetIniAbbrPathName())
    else begin
      aCountry.Text:=FileToString(Gcm2GetIniAbbrPathName());
      nBytes:=Length(sRes);
      //zpracovani dat podle vstupniho formatu
      case sFormat of
      'fullcsv': begin
                  GeoBusyKind('Kontrola struktury CSV souboru...');
                  if(Gcm2ParseCsvStruct(sParam)) then begin
                    GeoBusyKind('Parsovani a import...');
                    while(sRes<>'') do begin
                      GeoBusyProgress(Trunc(100*((0.+nBytes-Length(sRes))/nBytes)),100);
                      sParam:=Fetch(sRes,CRLF);
                      if(sParam[1]='"') then break; //konec dat
                      Gcm2ParseCsvData(sParam); //zpracujeme a ulozime jedno CWG
                      Inc(n);
                      //if(n>20) then break;     //////////////////////////////////////
                    end;
                  end;
                end;
      'fullxml': begin
                  GeoBusyKind('Zpracovani XML souboru...');
                  while(sRes<>'') do begin
                    GeoBusyProgress(Trunc(100*((0.+nBytes-Length(sRes))/nBytes)),100);
                    sParam:=Fetch(sRes,'</cwg>'); //zaznam jednoho CWG
                    Gcm2ParseXmlData(sParam); //zpracujeme a ulozime jedno CWG
                    Inc(n);
                    //if(n>20) then break;     //////////////////////////////////////
                  end;
                end;
      end;
    end;
  finally
    aCountry.Free();
  end;
  GeoBusyKind('Commit...');
  CwgDB.Commit('GCM');   //ukoncime transakci
  DBClose();
  //CwgForm.Show();
  cbDatabaseOnChange(nil); //zobrazime aktualizovanou databazi
end;

function Gcm2ComposeTagCountry(sAbbr:string):string;
begin
	Result:='  <tag>'+CRLF
	  +'    <name>'+Gcm2AbbrToCountry(sAbbr)+'</name>'+CRLF
		+'    <category>'+CRLF
		+'      <id>country</id>'+CRLF
		+'      <name>'+AnsiToUtf('Stt')+'</name>'+CRLF
		+'    </category>'+CRLF
		+'  </tag>'+CRLF;
end;

function Gcm2ComposeTagOrigin(sCat:string):string;
var sOrig:string;
begin
  //????? jaky je rozdil mezi Ostatni a Neznamy?
  //Osobní, Eventové, Keše, Limitky, Extra osobní, Ostatní, Neznámý
  case (sCat) of
  'CWG','SQ','MWG': sOrig:=AnsiToUtf('Neznm');
  'cwg','swg','wgp','sqp','mwp': sOrig:=AnsiToUtf('Osobn');
  'cle','sle': sOrig:=AnsiToUtf('Limitky'); //////??????
  'ceg','seg': sOrig:=AnsiToUtf('Extra osobn');  //??ceg00207, ale toto neni v seznamu kategorii
  'wge','sqe','mwe': sOrig:=AnsiToUtf('Eventov');
  'wgc','sqc','mwc': sOrig:=AnsiToUtf('Kee');
  'wgo','sqo','mwo': sOrig:=AnsiToUtf('Ostatn');
  else sOrig:=AnsiToUtf('Neznm');
  end;
	Result:='  <tag>'+CRLF
	  +'    <name>'+sOrig+'</name>'+CRLF
		+'    <category>'+CRLF
		+'      <id>origin</id>'+CRLF
		+'      <name>Typ</name>'+CRLF
		+'    </category>'+CRLF
		+'  </tag>'+CRLF;
end;

function Gcm2ComposeTagType(sCat:string):string;
var sType:string;
begin
  sType:='xWG';
  if(sCat='SQ') or (sCat='sq') or (sCat='sqp') or (sCat='sqe') or (sCat='sqc') or (sCat='sqo') then sType:='SQ';
  if(sCat='MWG') or (sCat='mwp') or (sCat='mwe') or (sCat='mwc') or (sCat='mwo') then sType:='MWG';
	Result:='  <tag>'+CRLF
	  +'    <name>'+sType+'</name>'+CRLF
     ////???? take muze byt
		+'    <category>'+CRLF
		+'      <id>type</id>'+CRLF
		+'      <name>Druh</name>'+CRLF
		+'    </category>'+CRLF
		+'  </tag>'+CRLF;
end;

//formatuje data jednoho CWG do XML formatu. Vstupni data uz jsou v UTF8.
function Gcm2ComposeGcmData(sName,sId,sCat,sVer,sDate,sCnt,sCacheId,
        sComName,sComCacheId,sComDate,sComImg,sGcmData,sCountry:string):string;
var rCmt:TrGcm2Cmt;
begin
  Result:='';
  //pripravime data komentare, ziskame GCM_ID
  rCmt:=Gcm2ParseComment(sGcmData);
  //upravime comment na aktualni hodnoty
  rCmt.sGcCode:=sCacheId;
  rCmt.sCmtDate:=sComDate;
  rCmt.sCmtName:=sComName;
  rCmt.sCmtGcCode:=sComCacheId;
  rCmt.sCmt:=sComImg;
  Result:='<cwg id="'+rCmt.sGcmId+'">'+CRLF;  //???? jak je to tu, pokud ho neznam nebo je CWG nove?
  //<cat_no> je zarazeno jen u katalogovych kusu
  if(StrToInt(sId)>0) then Result:=Result+'<cat_no>'+sCat+sId+'</cat_no>'+CRLF; //???? jak je to tu, pokud ma mit na konci jeste '-XX'
  Result:=Result+'<name>'+sName+'</name>'+CRLF
		+'<category id="1">Unknown category</category>'+CRLF //???????????
		+'<tags>'+CRLF
    +Gcm2ComposeTagCountry(sCountry)
		+Gcm2ComposeTagOrigin(sCat)    //??? Osobni, ....
		+Gcm2ComposeTagType(sCat)    //??? xWG, SQ, MWG
		+'</tags>'+CRLF
		+'<version>'+sVer+'</version>'+CRLF
		+'<image></image>'+CRLF          //????? ve zdroji je tu IMG uvedeno
		+'<collection>'+CRLF
		+'  <entry>'+CRLF
		+'    <date>'+Copy(sDate,1,4)+'-'+Copy(sDate,5,2)+'-'+Copy(sDate,7,2)+'</date>'+CRLF
		+'    <year></year>'+CRLF //?????
		+'    <comment>'+Gcm2ComposeComment(rCmt,true)+'</comment>'+CRLF
		+'    <pieces>'+sCnt+'</pieces>'+CRLF   //?????
		+'  </entry>'+CRLF
		+'</collection>'+CRLF
	  +'</cwg>'+CRLF
    ;
end;

function Gcm2Import:string; //import kolekce do GCM, vraci string s cislem,
var tab:TSQLiteTable;      //na ktery se odkazovat pro zjisteni stavu importu
    s,sSql,sCmd,sParam,sRes,sData:string;
    sName,sId,sCat,sVer,sDate,sCnt,sCacheId,
        sComName,sComCacheId,sComDate,sComImg,sGcmData,sCountry:string;
    i,nCwgMax:integer;
begin
  //CwgForm.Hide();
  Gcm2ReadToken();
  GeoBusyStart();
  GeoBusyCaption('Export dat na GCM server');
  GeoBusyKind('Priprava dat ...');
  Result:='';
  //pripravime soubor se zkratkami statu
  aCountry:=TStringList.Create();
  try
    if(not FileExists(Gcm2GetIniAbbrPathName())) then
      ShowMessage('ERR: nenalezen soubor '+Gcm2GetIniAbbrPathName())
    else begin
      aCountry.Text:=FileToString(Gcm2GetIniAbbrPathName());
      DBOpen();
      //ziskat pocet CWG, ktera zpracovat, abychom mohli zobrazit progressbar
      sSql:='SELECT count(id) FROM '+TABLE_FOUND+' WHERE '
           +' Category IN ("CWG","SQ","sq","MWG")'       //predmety mimo katalog
           +' OR Category LIKE "wg_" OR Category LIKE "sq_" OR Category LIKE "mw_"' //katalogove CWG, SQ, MWG
           +' OR Category LIKE "_wg"'  //stare osobni podle statu (cwg, swg, awg, ...)
           +' OR Category LIKE "_le"'  //stare limitovane podle statu (cle, sle, ale, ...)
           +' OR Category LIKE "_eg"'  //stare chybne podle statu (ceg, seg, aeg, ...)
      nCwgMax:=CwgDB.GetTableValue(sSql);
      i:=0;
      //sestavit XML se vsemi informacemi pro import do GCM
      sSql:=ReplaceString(sSql,'count(id)',
        +'Name, Id, Category, Version, DateFound, Cnt, CacheId,'
        +'CommentName, CommentCacheId, CommentDate, CommentImg,GcmData, Country');
      tab:=CwgDb.GetTable(s,false);
      try
        while not tab.eof do begin
          GeoBusyProgress(i,nCwgMax);
          sName:=tab.FieldByName['Name'];
          sId:=tab.FieldByName['Id'];
          sCat:=tab.FieldByName['Category'];
          sVer:=tab.FieldByName['Version'];
          sDate:=tab.FieldByName['DateFound'];
          sCnt:=tab.FieldByName['Cnt'];
          sCacheId:=tab.FieldByName['CacheId'];
          sComName:=tab.FieldByName['CommentName'];
          sComCacheId:=tab.FieldByName['CommentCacheId'];
          sComDate:=tab.FieldByName['CommentDate'];
          sComImg:=tab.FieldByName['CommentImg'];
          sGcmData:=tab.FieldByName['GcmData'];
          sCountry:=tab.FieldByName['Country'];
          sData:=sData+Gcm2ComposeGcmData(sName,sId,sCat,sVer,sDate,sCnt,sCacheId,
            sComName,sComCacheId,sComDate,sComImg,sGcmData,sCountry);
          tab.Next();
        end;
      finally
        tab.Free();
      end;
      DBClose();
      //zavolame funkci pro odeslani dat
      sCmd:='collection/import';
      //?????? jmeno ma byt jedinecne?
      sParam:='{"token":"", "options": {"format":"fullxml", "name":"CwgList",'
        +' "data":"'+sData+'", "flags":{"collect":true, "setOffers": false,'
        +'"unsetOffers":false, "exclusiveMode":false}, "wait":905597743}}';
      sRes:=Gcm2SendCmd(sCmd,sParam);
      Fetch(sRes,'"exportId":');    //z odpovedi ziskame ID rozpracovaneho pozadavku
      sId:=Fetch(sRes,'}');
      {$ifdef DEBUG_HELPER} LDH('Gcm2 - sId='+sId); {$endif}
      if(sId='') then exit; ///divne, k tomu by dojit nemelo
      //pockame na odpoved
      sData:=Gcm2WaitForImportComplete('import/query',sId);
    end;
  finally
    aCountry.Free();
  end;
  //CwgForm.Show();
end;

function Gcm2User(sCmd,sUser:string):string;
var sParam,sRes:string;
begin
  Result:='';
  Gcm2ReadToken();
  if(sCmd='info') then sParam:='{"token":""}'
  else sParam:='{"token":"", "user":"'+sUser+'"}';
  sRes:=Gcm2SendCmd('user/'+sCmd,sParam);
  StringToFile(Gcm2JsonToTxt(sRes),Gcm2GetDir()+'gcm-user_'+sCmd+'.json');
end;

function Gcm2GetTotalCount(sResponse:string):integer;
var i,iPos:integer;
    s,c:string;
begin
  Result:=0;
  //zjistime pocet polozek
  iPos:=Pos('"totalCount":',sResponse);
  if(iPos>0) then begin
    s:=Copy(sResponse,iPos,100);
    Fetch(s,'"totalCount":');
    for i:=1 to 10 do begin
      if(s[i]<'0') or (s[i]>'9') then begin //hledame prvni neciselny znak
        c:=s[i];
        Result:=StrToInt(Fetch(s,c));
        break;
      end;
    end;
  end;
{$ifdef DEBUG_HELPER} LDH('totalCount='+IntToStr(Result)); {$endif}
end;

function Gcm2Tags(sCmd,sFilter,sDisplay:string; limit,offset:integer; var nItems:integer):string;
  //sFilter filtruje kategorie tagu (systemove, uzivatelske), jejich seznam
  //        a to, zda vracet i kategorie, do nichz neni zarazeno zadne xWG
  //sDisplay definuje pocet zobrazenych kategorii (implicitne 100)
var sParam:string;
begin                  //nacte vsechny tagy, pocet jejich pouziti, rozdeli je podle kategorii
  Result:='';
  Gcm2ReadToken();
  sParam:='{"token":""';
  if(sFilter<>'') then sParam:=sParam+', "filterOptions": '+sFilter;
  if(sDisplay<>'') then sParam:=sParam+', "displayOptions": '
    +ReplaceString(ReplaceString(sDisplay,'"offset":#','"offset":'+IntToStr(offset)),
    '"limit":#','"limit":'+IntToStr(limit));
  sParam:=sParam+'}';
  Result:=Gcm2JsonToTxt(Gcm2SendCmd('tags/'+sCmd,sParam));
  nItems:=Gcm2GetTotalCount(Result);
  StringToFile(Result,Gcm2GetDir()+'gcm-tags_'+sCmd+'-'+IntToStr(offset)+'.json');
end;

procedure Gcm2GetTags;
var sRes,sTagName,sTagCount,sCatId,sCatName:string;
    aCategory:TStringList;
    i,ii,nItems,nLimit,iOffset:integer;
begin
  CwgForm.Hide();
  GeoBusyStart();
  GeoBusyCaption('gcm - xwg.query');
  nItems:=1;
  nLimit:=1000; //krok, po kolika nacitame tagy
  iOffset:=0;
  i:=0;
  ii:=1;
  aCategory:=TStringList.Create();
  try
    while((i<nItems) and (ii>0)) do begin       //zacyklime, dokud neni nacteno vsechno
      GeoBusyProgress(iOffset,nItems);
      ii:=0; //pocet tagu v tomto souboru
      sRes:=Gcm2Tags('query','','{"limit":#, "offset":#, "showItemCount":true}',nLimit,iOffset,nItems);
      //rozebereme a ziskame seznam vsech tagu a k nim pocty a kategorie
      Fetch(sRes,'"tags":[{');
      while (sRes<>'') do begin
        GeoBusyProgress(i,nItems);
        Fetch(sRes,'"name":"');       sTagName:=Fetch(sRes,'"');    //hodnota tagu
        Fetch(sRes,'"itemCount":"');  sTagCount:=Fetch(sRes,'"');   //pocet pouziti
        Fetch(sRes,'"id":"');         sCatId:=Fetch(sRes,'"');      //id kategorie
        Fetch(sRes,'"name":"');       sCatName:=Fetch(sRes,'"');    //jmeno kategorie
        if(sRes='') then break;
        if(aCategory.Values[sCatId]='') then aCategory.Values[sCatId]:=''
        else aCategory.Values[sCatId]:=aCategory.Values[sCatId]+', ';
        aCategory.Values[sCatId]:=aCategory.Values[sCatId]+sTagName+' ('+sTagCount+')';
        Inc(i);
        Inc(ii);
      end;
//{$ifdef DEBUG_HELPER} LDH('i='+IntToStr(i)+', ii='+IntToStr(ii)+', Items='+IntToStr(nItems)); {$endif}
      iOffset:=iOffset+ii;
    end;
    ShowMessage('Pocet zpracovanych tagu: '+IntToStr(i)+'/'+IntToStr(nItems)+CRLF
               +'Pocet kategorii: '+IntToStr(aCategory.Count));
    StringToFile(aCategory.Text,Gcm2GetDir()+'Tags-category.txt');
  finally
    aCategory.Free();
  end;
  CwgForm.Show();
end;

procedure Gcm2GetCategories;
var sData,sCategory,s:string;
    i,nItems:integer;
    b:boolean;
begin
  //ziskame soubor s hornotami tagu pro zakladni kategorie
  Gcm2Tags('categories','{"categories":["origin","type","country"]}','{"tags":true}',1000,0,nItems);
  //parsujeme ziskana data
  sData:=FileToString(Gcm2GetDir()+'gcm-tags_categories.json');
  Fetch(sData,'"categories":[{');
  while(sData<>'') do begin  //parsujeme vsechny kategorie
    Fetch(sData,'"id":"');
    if(sData='') then break;
    Inc(i);
    sCategory:=sCategory+Fetch(sData,'",')+': ';
    Fetch(sData,'"tags":[{');
    b:=false;
    s:='';
    while ((b=false) and (sData<>'')) do begin//parsujeme vsechny polozky teto kategorie
      Fetch(sData,'"name":"');
      s:=s+Fetch(sData,'"}')+CRLF;
      b:=(sData[1]=']'); //konec jedne kategorie?
    end;
    sCategory:=sCategory+ReplaceString(Trim(s),CRLF,', ')+CRLF; //zapiseme polozky kategorie
  end;
  StringToFile(sCategory,Gcm2GetDir()+'Category-tags.txt');
  ShowMessage('Pocet ziskanych kategorii: '+IntToStr(i));
end;

function Gcm2Xwg(sCmd,sFilter,sDisplay:string; limit,offset:integer; var nItems:integer):string;
  //sFilter filtruje kategorie tagu (systemove, uzivatelske), jejich seznam
  //        a to, zda vracet i kategorie, do nichz neni zarazeno zadne xWG
  //sDisplay definuje pocet zobrazenych kategorii (implicitne 100)
var sParam:string;
begin                  //nacte vsechny tagy, pocet jejich pouziti, rozdeli je podle kategorii
  Result:='';
  Gcm2ReadToken();
  sParam:='{"token":""';
  if(sFilter<>'') then sParam:=sParam+', "filterOptions": '+sFilter;
  if(sDisplay<>'') then sParam:=sParam+', "displayOptions": '
    +ReplaceString(ReplaceString(sDisplay,'"offset":#','"offset":'+IntToStr(offset)),
    '"limit":#','"limit":'+IntToStr(limit));
  sParam:=sParam+'}'
  Result:=Gcm2JsonToTxt(Gcm2SendCmd('xwg/'+sCmd,sParam));
  //zjistime pocet polozek
  nItems:=Gcm2GetTotalCount(Result);
  StringToFile(Result,Gcm2GetDir()+'gcm-xwg_'+sCmd+'-'+IntToStr(offset)+'.json');
end;

procedure Gcm2GetXwg(sTagValue,sTagCategory:string);
var sRes,sRow,sId,sName,sVer,sCatNo,sNote,sTags,sTagVal,sTagCat:string;
    aCwg:TStringList;
    i,ii,nItems,nLimit,iOffset:integer;
    bCategory:boolean;
begin
  CwgForm.Hide();
  GeoBusyStart();
  GeoBusyCaption('gcm - xwg.query');
  nItems:=1;
  nLimit:=100; //krok, po kolika nacitame tagy
  iOffset:=0;
  i:=0;
  ii:=1;
  aCwg:=TStringList.Create();
  try
    while((i<nItems) and (ii>0)) do begin       //zacyklime, dokud neni nacteno vsechno
      GeoBusyProgress(iOffset,nItems);
      ii:=0;      //pocet CWG v tomto souboru
      sRes:=Gcm2Xwg('query'
        ,'{"collected":false, "tags":[{"name":"'+sTagValue+'", "category":"'+sTagCategory+'"}]}'
        ,'{'
          +'"sort":[{"columnName":"name","direction":"ASC"},{"columnName":"version","direction":"ASC"}], '
          +'"limit":#, "offset":#, '
          +'"show":["id","name","version","cat_no","note","tags"'
          //+',"collected","offered","wanted","nowanted","collection","offer"'
          +']}'
        ,nLimit,iOffset,nItems);
      //rozebereme a ziskame seznam vsech polozek
      Fetch(sRes,'"items":[{');
//{$ifdef DEBUG_HELPER} LDH('------- Start zpracovani davky, len='+IntToStr(Length(sRes))+':'+Copy(sRes,1,100)+'...'); {$endif}
      while (sRes<>'') do begin
        GeoBusyProgress(i,nItems);
        Fetch(sRes,'"id":"');         sId:=Fetch(sRes,'",');      //id CWG
//if(sId='614735') then begin
//{$ifdef DEBUG_HELPER} LDH('sRes='+Copy(sRes,1,20)+'...'); {$endif}
//end;
        Fetch(sRes,'"name":"');       sName:=Fetch(sRes,'",');    //hodnota tagu
//if(sId='614735') then begin
//{$ifdef DEBUG_HELPER} LDH('sRes='+Copy(sRes,1,20)+'...'); {$endif}
//end;
        Fetch(sRes,'"version":"');    sVer:=Fetch(sRes,'",');     //pocet pouziti
        //katalogove cislo muze byt null (bez uvozovek), proto hledame bez nich
        //pokud nebude katalogove cislo, pak asi bude potreba kontrolovat pres
        //interni ID v gcm
        Fetch(sRes,'"cat_no":');      sCatNo:=ReplaceString(Fetch(sRes,','),'"','');
        Fetch(sRes,'"note":"');       sNote:=Fetch(sRes,'",'+CRLF);    //poznamka
//if(sId='614735') then begin
//  {$ifdef DEBUG_HELPER} LDH('sId='+sId+', sName='+sName+', sVer='+sVer+', sCatNo='+sCatNo+', sNote='+sNote); {$endif}
//  sRes:='';
//  i:=nLimit;
//  break;
//end;
        sNote:=ReplaceString(sNote,CRLF,' ');
//{$ifdef DEBUG_HELPER} LDH('sId='+sId+', sName='+sName+', sVer='+sVer+', sCatNo='+sCatNo+', sNote='+sNote); {$endif}
        if(sRes='') then break;
        //ted vsechny tagy
        Fetch(sRes,'"tags":[{');
        sTags:='';
        bCategory:=false;
        sTagVal:='';
        sTagCat:='';
        while(sRes<>'') do begin
          sRow:=Fetch(sRes,CRLF);
          if(sRow='}]') then break; //konec vsech tagu pro toto CWG
          if(Pos('"categories":',sRow)>=1) then bCategory:=true;
          if(bCategory) then begin
            if(Pos('"name":"',sRow)>=1) then begin
              //hodnotu ignorujeme, ale je to posledni polozka kategorie, tak tag ulozime
              bCategory:=false;
              if(sTags<>'') then sTags:=sTags+'; ';
              sTags:=sTags+sTagCat+'='+sTagVal;
            end;
            if(Pos('"id":"',sRow)>=1) then begin
              Fetch(sRow,'":"');
              sTagCat:=Fetch(sRow,'"');
            end;
          end
          else begin
            if(Pos('"name":"',sRow)>=1) then begin
              Fetch(sRow,'":"');
              sTagVal:=Fetch(sRow,'"');
            end;
          end;
        end;
        if(sRes='') then break;
        //asi bude problem se jmeny obsahujici '='
        if(aCwg.Values[sName]='') then aCwg.Values[sName]:=''
        else aCwg.Values[sName]:=aCwg.Values[sName]+', ';
        aCwg.Values[sName]:=aCwg.Values[sName]+sCatNo+','+sVer+','+sId+', '+sTags+', '+sNote;
        Inc(i);
        Inc(ii);
      end;
//{$ifdef DEBUG_HELPER} LDH('------- i='+IntToStr(i)+', ii='+IntToStr(ii)+', Items='+IntToStr(nItems)); {$endif}
      //StringToFile(aCwg.Text,Gcm2GetDir()+'xwg-query_'+IntToStr(iOffset)+'.txt');
      iOffset:=iOffset+ii;
    end;
    StringToFile(aCwg.Text,Gcm2GetDir()+'xwg-query.txt');
    ShowMessage('Pocet zpracovanych xwg: '+IntToStr(i)+'/'+IntToStr(nItems));
  finally
    aCwg.Free();
  end;
  CwgForm.Show();
end;

function lGcm2GetSelFunction:string;
var idx:integer;
    sRow,sFce:string;
begin
  Result:='';
  CwgForm_sGcm2Desc.Caption:='';
  idx:=CwgForm_lGcm2Cmds.ItemIndex;
  if(idx<0) then exit;
  sFce:=CwgForm_lGcm2Cmds.Items[idx];
  if(sFce[1]='-') then exit; //je to jen nadpis skupiny funkci
  //najdeme nadpis skupiny funkci
  for idx:=idx-1 downto 0 do begin
    sRow:=CwgForm_lGcm2Cmds.Items[idx];
//{$ifdef DEBUG_HELPER} LDH('Gcm2 - sRow='+sRow); {$endif}
    if(sRow[1]='-') then begin
      Fetch(sRow,' ');
      Result:=sRow+'.'+sFce;
      break;
    end;
  end;
end;

procedure lGcm2CmdsOnClick(Sender: TObject);
var sFce:string;
    ini:TMemIniFile;
begin
  sFce:=lGcm2GetSelFunction();
//{$ifdef DEBUG_HELPER} LDH('Gcm2 - sFce='+sFce); {$endif}
  if(sFce='') then exit;
  ini:=TMemIniFile.Create(Gcm2GetIniPathName());
  try
    CwgForm_sGcm2Desc.Caption:=ini.ReadString(sFce,'Desc',''); //zobrazime popis
  finally
    ini.Free();
  end;
end;

function Gcm2GetUsername(sFce:string):string;
begin
  Result:=InputBox('Zadn uivatele','Pro funkci'+CRLF+sFce+CRLF+'zadejte uivatele',GCM_USER);
end;

procedure butGcm2OkOnClick(Sender: TObject);
var sFce:string;
begin
  sFce:=lGcm2GetSelFunction();
  sFce:=ReplaceString(sFce,'moje.',''); //odstranime uvodni "umele pridanou" sekci
  case sFce of
  'collection.export': Gcm2Export();    //nacist data z gcm
  'collection.import': Gcm2Import();    //odeslat data na gcm
  'user.info':         Gcm2User('info','');
  'user.profile':      Gcm2User('profile',Gcm2GetUsername('Naten profilu'));
  'user.statistics':   Gcm2User('statistics',Gcm2GetUsername('Naten statistiky'));
  'tags.query':        Gcm2GetTags(); //seznam vsech hodnot tagu s uvedenim poctu a kategorie, do ktere tag patri
  'tags.categories':   Gcm2GetCategories(); //seznam kategorii a tagu v nich
  /////////////
  'getMWG':            Gcm2GetXwg('MWG','type');
  'getSQ':             Gcm2GetXwg('SQ','type');
  'getxWG':            Gcm2GetXwg('xWG','type');
  end;
end;

procedure lGcm2NewLoginOnClick(Sender: TObject); //vynuti nove prihlaseni
begin
  Gcm2GetTokenFromGcm(GEOGET_OWNER,true);
end;

procedure InitGcm2;
var i:integer;
    s:string;
begin
  ForceDirectories(Gcm2GetDir());
  CwgForm_butGcm2Ok.OnClick:=@butGcm2OkOnClick;
  CwgForm_butGcm2NewLogin.OnClick:=@lGcm2NewLoginOnClick;
  CwgForm_lGcm2Cmds.OnClick:=@lGcm2CmdsOnClick;
  //vypustit ze seznamu vsechny prikazy, ktere zacinaji *
  for i:=CwgForm_lGcm2Cmds.Items.Count-1 downto 1 do begin
    s:=CwgForm_lGcm2Cmds.Items[i];
    if(s<>'') then
      if(s[1]='*') then CwgForm_lGcm2Cmds.Items.Delete(i);
  end;
end;