const sGcm2Url='https://cwg.gcm.cz/api/v1/';
      sGcm2LoginUrl='http://gord.8u.cz/Geocaching/OAuth2/gcm.php';
var sGcm2Token:string;

function Gcm2GetTokenPathname:string;
begin Result:=Gcm2GetDir()+'Gcm2.token'; end;

procedure Gcm2TokenToIni(sToken:string);
var ini:TMemIniFile;
begin
{$ifdef DEBUG_HELPER} LDH('Gcm2 - Gcm2TokenToIni() - save token to file'); {$endif}
  ini:=TMemIniFile.Create(Gcm2GetTokenPathname());
  try
    ini.WriteString('Main','Token',sToken);
    ini.WriteString('Main','Date',FormatDateTime('dd"."mm"."yyyy hh":"nn',Now()));
    ini.UpdateFile();
  finally
    ini.Free();
  end;
end;

function Gcm2TokenFromIni:string;
var ini:TMemIniFile;
begin
{$ifdef DEBUG_HELPER} LDH('Gcm2 - Gcm2TokenFromIni() - read token from file'); {$endif}
  Result:='';
  ini:=TMemIniFile.Create(Gcm2GetTokenPathname());
  try
    Result:=ini.ReadString('Main','Token',''); //zobrazime popis
  finally
    ini.Free();
  end;
{$ifdef DEBUG_HELPER} LDH('Gcm2 - Gcm2TokenFromIni() - token='+Result); {$endif}
end;

function Gcm2ServerEnable:boolean;
var ini:TMemIniFile;
    i:integer;
begin
  //pokud je potreba, informuje o pouziti meho serveru pro prihlaseni na gcm
  Result:=false; //zakaz prace s gcm serverem
  ini:=TMemIniFile.Create(Gcm2GetTokenPathname());
  try
    i:=ini.ReadInteger('Main','LoginWarn',1);
    if(i=1) then begin
      i:=MessBox('Pihlen k serveru gcm.cz je udlan tak, e v podstat '
                 +'vyaduje webovou aplikaci. Protoe Geoget takovou aplikac '
                 +'nen a bt dost dobe neme, pihlen probh pomoc '
                 +'mho webu (gord.8u.cz). Prohlauji, e token na serveru '
                 +'nen uchovvn a nemm v myslu pihlen ke gcm serveru '
                 +'zneuvat.'+CRLF+CRLF
	               +'        Ano - OK, upozornit pi kadm pihlen'+CRLF
	               +'        Ne - OK, ji neupozorovat'+CRLF
	               +'        Storno - nepracovat s GCM serverem'+CRLF
                 ,'Pout webovho serveru',3);
      if((i=6) or (i=2)) then ini.WriteInteger('Main','LoginWarn',1)
      else ini.WriteInteger('Main','LoginWarn',0);
      if((i=6) or (i=7)) then Result:=true; //prace se serverem povoloen
      ini.UpdateFile();
    end else Result:=true;
  finally
    ini.Free();
  end;
end;

procedure Gcm2RemoveToken;
begin
  sGcm2Token:='';
  Gcm2TokenToIni(sGcm2Token);
end;

//nacte z meho serveru token
function Gcm2ReadToken:string;
var b:boolean;
    i:integer;
    s:string;
begin
{$ifdef DEBUG_HELPER} LDH('Gcm2 - GetToken() - start'); {$endif}
  //pokud je potreba, drive ulozeny token
  if(sGcm2Token='') then sGcm2Token:=Gcm2TokenFromIni();
  Result:=sGcm2Token;
  if(sGcm2Token<>'') then exit;
  //po sekundach kontrolujeme, zda uz neni token k dispozici
  //http://gord.8u.cz/Geocaching/OAuth2/gcm.php?TokenForUser=hipogrys
  s:=sGcm2LoginUrl+'?'+'TokenForUser='+GEOGET_OWNER;
{$ifdef DEBUG_HELPER} LDH('Gcm2 - zadost o token, (POST) URL=:'+s); {$endif}
  b:=HttpAsk('POST',s,'text/json','',Result);
{$ifdef DEBUG_HELPER} LDH('Gcm2 - navrat s tokenem='+Result); {$endif}
  i:=Pos('Token=',Result);
  if(i>=1) then begin
    s:=Copy(Result,i,200);
    Fetch(s,'=');
    Result:=Fetch(s,'<');
    sGcm2Token:=Result;
    Gcm2TokenToIni(Result);
{$ifdef DEBUG_HELPER} LDH('Gcm2 - token='+Result); {$endif}
  end
  else Result:='';
end;

//ziska token pro praci se serverem
function Gcm2GetTokenFromGcm(sNick:string; bNewForce:boolean):string;
var i:integer;
begin
  Result:='';
  Gcm2RemoveToken();
  if(not Gcm2ServerEnable()) then exit;
{$ifdef DEBUG_HELPER} LDH('Gcm2 - Gcm2GetTokenFromGcm() - start'); {$endif}
  if(bNewForce) then RunShell(sGcm2LoginUrl+'?NewLogin=y&state='+sNick) //vynutime nove prihlaseni
  else RunShell(sGcm2LoginUrl+'?state='+sNick);//zavolame moji funkci pro prihlaseni
  //pockame max 2 minuty na prihlaseni
  for i:=0 to 120 do begin
    Result:=Gcm2ReadToken(); //nacteme token ze meho serveru
    if(Result<>'') then exit; //prihlaseno
    Sleep(1000); //pockame sekundu a zkusime znovu
  end;
end;

//vrati priznak, zda doslo k chybe, ktera vyzaduje ziskani tokenu (liche cislo)
//a zda doslo k chybe (>1)
function Gcm2NeedToken(sResponse:string):integer;
var s:string;
    i:integer;
begin
  // ---- navratove kody podle RFC
  //200 OK
  //202 priprava dat exportu/imortu zarazena do fronty ke zpracovani
  //400 Bad Request
  //401 Unauthorized
  //403 Forbidden (toto by melo byt jen v pripade chybne hodnoty parametru
  //              scope, coz ale gcm nepouziva)
  //404 Not Found - Invalid Refresh Token
  //                Invalid Access Token
  //                Invalid Client ID
  //                Invalid Authorization Code
  //500 Not Found - Expired Access Token
  //                Expired Refresh Token
  //                Expired Authorization Code
  s:=Copy(sResponse,1,100);
  Fetch(s,'"status":');
  s:=Copy(s,1,3);
  i:=StrToInt(s);
  //404 je navratova hodnota pri chybnem ID pro export.get a pak to cykli
  //    se zjistovanim tokenu, protoze si mysli, ze neni spravne token
  Result:=0;
  if((i=401) or (i=403) { or (i=404)} or (i=500)) then begin
    Result:=1;
    Gcm2RemoveToken();  //smazeme pripadny stary token, abychom vynutili prihlaseni
  end;
  if((i>400) and (i<>401) and (i<>403) and (i<>500)) then begin
    ShowMessage('Chyba GCM serveru:'+CRLF+CRLF+sResponse);
    Result:=Result+2;
  end;
{$ifdef DEBUG_HELPER} LDH('Gcm2 - Gcm2NeedToken='+IntToStr(Result)+', i='+IntToStr(i)); {$endif}
end;
