//funkce pro import CWG z HTML souboru vytvoreneho Statorem
//pracuje ale jen s "kartama CWG", ne se seznamem
var nStatorCount:integer;
    nStatorAdd,nStatorIgnoreExists,nStatorIgnoreOld:integer;
    hStatorProt:TFileStream;

procedure StatorLog(str:string);
begin
  hStatorProt.WriteBuffer(str+CRLF, Length(str)+2);
end;

function ParseStatorId(sStatorId:string; var sCategory,sId:string; var iNum:integer):boolean;
var s:string;
begin
  if(Pos('-?',sStatorId)>0) then begin //nekatalogova CWG
    sCategory:=Fetch(sStatorId,'-?');
    sId:='';
    iNum:=1;
    Result:=false;
    exit;
  end;
  s:=RegexSubstitute('([a-zA-z]+)([0-9]+)(.*)',sStatorId,'$1|$2|$3');
  sCategory:=Fetch(s,'|');
  sId:=Fetch(s,'|');
  iNum:=ShortSuffixToVer(s);
  Result:=((sCategory<>'') and (sId<>''));
end;

procedure StatorSaveListCwg; //ulozi seznam pripravenych parsovanych CWG do databaze
begin
end;

function StatorCwgExists():boolean;
begin
  Result:=false;
end;

procedure StatorAddCwg(sName,sStatorId,sGuid,sCountry,sGcCode,sImg,sDate,sNameComment,sGcComment,sDateComment:string);
var s,sId,sCategory,sSql:string;
    iVer,iFlag:integer;
    b,bAdd:boolean;
begin //ulozi ziskane ingormace o CWG do seznamu k pridani
  Inc(nStatorCount); //zvysime pocet zapsanych CWG
  bAdd:=true; //predpokladame, ze CWG budeme do databaze pridavat
  b:=ParseStatorId(sStatorId, sCategory, sId, iVer);  //ze sStatorId separujeme kategorii, ID a verzi
  //pokud se nepodarilo parsovat sStatorId, asi jde o nekatalogove CWG, parsujeme jmeno
  if(not b) then begin
    //sCategory:=Fetch(sStatorId,'-'); //uz je naplnena z parsovani
    s:=RegexSubstitute('(.*)\ *\(v([0-9]+)\)',sName,'$1|$2');
    if(s<>'') then begin
      sName:=Fetch(s,'|');
      iVer:=StrToInt(s);
//{$ifdef DEBUG_HELPER} LDH('XXXXXXXX nekatalogove s verzi '+sCategory+', sName='+sName+', iVer='+IntToStr(iVer)); {$endif}
    end
    else begin
//{$ifdef DEBUG_HELPER} LDH('XXXXXXXX nekatalogove bez verze '+sCategory+', sName='+sName); {$endif}
    end;
  end;
  //pokud jmeno obsahuje na konci '(vX)' a iVer je vetsi nez 1, odstranime cislo verze
  s:=sName;
  sName:=Fetch(s,'(v'+IntToStr(iVer)+')');
  //URL obrazku (sImg) bereme jen kdyz neni z originalniho serveru (http://geokatalog.cz/pic/)
  //a jen kdyz neni CwgMissing.jpg
  if(Pos('/stator/img/CwgMissing.jpg',sImg)>0) then sImg:=''
  else if(Pos('/stator/img/SqMissing.jpg',sImg)>0) then sImg:=''
  //katalogove SQ maji URL napr.: http://geocatalog.cz/pic/sqe00079-1.jpg
  //bude potreba je nejak odlisit o CWG, protoze SQ v katalogu nejsou
  //proto neni jak urcitit jejich ID, aby se automaticky vygeneroval odkaz na obrazek
  else if(Pos('/geokatalog.cz/pic/',sImg)>0) and   //katalogove CWG nebo SQ
    (Pos('/sq',sImg)<1) then sImg:='';             //a neni to SQ
  //if(Pos('/cwg.geog.cz/',sImg)>0) then sImg:='';
  StatorLog('Zpracovani CWG: n='+IntToStr(nStatorCount)+', sName='+sName
    +', sStatorId='+sStatorId+' (b='+IntToStr(b as integer)+', sId='+sId+', sCat='+sCategory+', iVer='+IntToStr(iVer)+')'
    +', sGuid='+sGuid+', sCountry='+sCountry+', sGcCode='+sGcCode
    +', sImg='+sImg+', sDate='+sDate
    +', NameCmt='+sNameComment+', GcCmt='+sGcComment+', DateCmt='+sDateComment);
//{$ifdef DEBUG_HELPER} LDH('Pridavam CWG: n='+IntToStr(nStatorCount)+', sName='+sName
//  +', sStatorId='+sStatorId+' (b='+IntToStr(b as integer)+', sId='+sId+', sCat='+sCategory+', iVer='+IntToStr(iVer)+')'
//  +', sGuid='+sGuid+', sCountry='+sCountry+', sGcCode='+sGcCode
//  +', sImg='+sImg+', sDate='+sDate
//  +', NameCmt='+sNameComment+', GcCmt='+sGcComment+', DateCmt='+sDateComment); {$endif}
  //zkontrolujeme, zda je CWG v databazi, pokud ne, pridame ho do seznamu
  if(b) then begin
//{$ifdef DEBUG_HELPER} LDH('Test CWG v databazi'); {$endif}
    sSql:='SELECT count(id) FROM '+TABLE_FOUND+' WHERE id=:id AND Category=:cat AND Version=:ver';
    CwgDB.AddParamText(':id',sId);
    CwgDB.AddParamInt(':ver',iVer);
    CwgDB.AddParamText(':cat',AnsiToUtf(sCategory));
    s:=CwgDB.GetTableString(sSql);
    if(s<>'0') then begin
    StatorLog('   ------ Katalogove CWG, jiz je jako ziskane, pridani preskoceno.');
//{$ifdef DEBUG_HELPER} LDH('------ Katalogove CWG, jiz je jako ziskane, pridani preskoceno.'); {$endif}
      Inc(nStatorIgnoreExists);
      exit;
    end;
  end;
  if(not b) then begin
    //pokud bylo pozadovano vymazani ziskanych CWG pred importem, datum ignorujeme
    //a importujeme vzdy
    //pokud je CWG ziskane davno, ignorujeme jej
    if(not StatorForm_bClear.Checked) and (Trunc(DDMMRRRRToDate(sDate))<=Trunc(StatorForm_dDb.Date)) then begin
      StatorLog('   ------ Nekatalogove CWG, ziskano pred zadanym datem, pridani preskoceno.');
//{$ifdef DEBUG_HELPER} LDH('------ Nekatalogove CWG, ziskano pred zadanym datem, pridani preskoceno.'); {$endif}
      Inc(nStatorIgnoreOld);
      exit;
    end;
    //musime najit posledni verzi, ktera je ziskana. Nizke verze (rekneme do 50) jsou asi katalogove, proto nas nezajimaji
    sSql:='SELECT min(version) FROM '+TABLE_FOUND+' WHERE Name=:name AND Category=:cat AND Version>50 ORDER BY Version DESC';
    CwgDB.AddParamText(':name',AnsiToUtf(sName));
    CwgDB.AddParamText(':cat',AnsiToUtf(sCategory));
    s:=CwgDB.GetTableString(sSql);
    if(s='') or (s='0') then iVer:=99 //nastavime nejvyssi cislo verze
    else iVer:=StrToInt(s)-1;
    sId:=IntToStr(UpdateLastId(true)); //zjistime ID dalsiho nekatalogoveho CWG
    StatorLog('Nekatalogove CWG, pridavam jako verzi '+IntToStr(iVer)+' a ID='+sId);
//{$ifdef DEBUG_HELPER} LDH('   Nekatalogove CWG, pridavam jako verzi '+IntToStr(iVer)+' a ID='+sId); {$endif}
  end;
  //pokud je zadane datum i kes, zjistime, zda se shoduje s nalezem kese a podle
  //toho nastavime priznak ziskani v kesi na 0/1. Pokud neni, priznak je 2
  iFlag:=2;
  if(sDate<>'') and (sGcCode<>'') then begin
    GEOGET_DB.AddParamText(':id',sGcCode);
    s:=GEOGET_DB.GetTableString('SELECT dtfound FROM geocache WHERE id=:id');
    if(s=DateToInt(DDMMRRRRToDate(sDate))) then iFlag:=0
    else iFlag:=1;
  end;
  //kontroly prosly, CWG pridame do databaze
  StatorLog('   +++ pridani CWG do databaze');
//{$ifdef DEBUG_HELPER} LDH('+++++++++++++++++ pridani CWG do databaze'); {$endif}
  Inc(nStatorAdd);
  CwgDB.AddParamInt(':id',StrToInt(sId));
  CwgDB.AddParamInt(':ver',iVer);
  CwgDB.AddParamText(':name',AnsiToUtf(sName));
  CwgDB.AddParamText(':cat',AnsiToUtf(sCategory));
  if(sDate='') then  CwgDB.AddParamText(':dat','')
  else CwgDB.AddParamText(':dat',DateToInt(DDMMRRRRToDate(sDate)));
  CwgDB.AddParamInt(':isdat',iFlag);
  CwgDB.AddParamInt(':cnt',1);
  //teoreticky tam muze byt jakykoli text, proto prevod na UTF
  CwgDB.AddParamText(':cacheId',AnsiToUtf(sGcCode));
  CwgDB.AddParamText(':img',sImg);
  CwgDB.AddParamText(':guid',sGuid);
  CwgDB.AddParamText(':comName',AnsiToUtf(sNameComment));
  CwgDB.AddParamText(':comId',AnsiToUtf(sGcComment));
  CwgDB.AddParamText(':comDate',AnsiToUtf(sDateComment));
  CwgDB.AddParamText(':comImg',AnsiToUtf(''));
  CwgDB.AddParamText(':group',AnsiToUtf(''));
  CwgDB.AddParamText(':nameUp',AnsiToUpAscii(sName)+VerToSuffix(iVer));
  CwgDB.AddParamText(':gcmData',AnsiToUtf(''));
  CwgDB.AddParamText(':svetgcData',AnsiToUtf(''));
  CwgDB.AddParamText(':country',AnsiToUtf(sCountry));
  CwgDB.ExecSQL('INSERT INTO '+TABLE_FOUND
    +' (NameUpAscii,    Name,  Id,  Category, Version, DateFound, Cnt,  CacheId,  Img,  GUID,  CommentName, CommentCacheId, CommentDate, CommentImg, TabGroup, IsCacheFound, GcmData, SvetGcData, Country) '
    +' VALUES (:nameUp, :name, :id, :cat,     :ver,    :dat,     :cnt, :cacheId, :img, :guid, :comName,    :comId,         :comDate,    :comImg,    :group,    :isdat,      :gcmData, :svetgcData,:country)'
    );
end;

function StatorGetAttrib(sDiv,sAttrib:string):string;
begin //nacte attribut title
  Fetch(sDiv,sAttrib+'="');
  Result:=Fetch(sDiv,'"');
end;

function StatorGetText(sDiv:string):string;
begin //nacte attribut title
  Fetch(sDiv,'>');
  Result:=Fetch(sDiv,'<');
end;

procedure StatorParseTables(sFile:string);
var sHtml,sRow,
    sName,sId,sCountry,sGcCode,sDate:string;
    nMax,MaxLen,iTd:integer;
    bStart:boolean;
begin
  sHtml:=FileToString(sFile);
  MaxLen:=Length(sHtml);
  ShowMessage('Import textovych tabulek ze Statoru zatim neni implementovan.');
  exit;
  //!!!!!!!!!!!!! neni jak odlisit katalogove a nekatalogove, zatim tabulky ignoruji
  //!!! uzivatel muze volit sloupce, ktere v tabulce budou, ale nemam moc jak
  //!!! odlisit kategorii, jmeno, datum, poradi, tak je potreba rozebrat hlavicku
  //!!! a zkusit z ni odhadnout jednotlive sloupce.
  nMax:=99999;
  bStart:=true;
  while(sHtml<>'') do begin
    if(nStatorCount>nMax) then begin
{$ifdef DEBUG_HELPER} LDH('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX Preruseno zpracovani prekrocenim poctu nMax='+IntToStr(nMax)); {$endif}
      break;
    end;
    GeoBusyProgress(Trunc(100*((0.+MaxLen-Length(sHtml))/MaxLen)),100);
    if(bStart) then begin //hledame zacatek tabulky s CWG
      Fetch(sHtml,'<!-- StatorTitle'); //najdeme zacatek vypisu modulu
      Fetch(sHtml,'</div>'); //konec nadpisu, za nim musi nasledovat <table>, jinak to neni tabulka, ale karty s CWG
      if(Pos('<table',sHtml)<>1) then continue;
      Fetch(sHtml,'</tbody>'); //preskocime hlavicku tabulky
      bStart:=false;
      iTd:=0;
    end;
    sRow:=Fetch(sHtml,'</td>'); //nacteme bunku
    Inc(iTd);
    //poradi sloupce neni pevne, proto to nejde udelat pres case()
    case iTd of
    0: begin                    //stat
         Fetch(sRow,'<img');
         sCountry:=StatorGetAttrib(sRow,'title');
         continue;
       end;
    1: begin sName:=StatorGetText(sRow); continue; end;
    2: begin sDate:=StatorGetText(sRow); continue; end;
    3: begin sGcCode:=StatorGetText(sRow); continue; end;
    4: begin //sloupec s informaci o kesi ignorujeme, jen ho pouzijeme k zapsani CWG
         if(sName<>'') then begin
           StatorAddCwg(sName,sId,'',sCountry,sGcCode,'',sDate,'','','');
         end;
         iTd:=0;
       end;
    else begin
           //nacteme dalsi tabulku, pokud tam je
           if(Pos('<!-- End of StatorModule CwgList',sRow)>0) then begin
             bStart:=true;
             continue;
           end;
         end;
    end;
  end;
end;

procedure StatorParseCards(sFile:string);
var s,sHtml,sDiv,
    sName,sId,sGuid,sCountry,sGcCode,sImg,sDate,sNameComment,sGcComment,sDateComment:string;
    nMax:integer;
    bCountry:boolean;
    MaxLen:integer;
begin
  sHtml:=FileToString(sFile);
  MaxLen:=Length(sHtml);
  //parsuje vsechny sekce s kartami s CWG
  Fetch(sHtml,'<div id="iCwg_'); //najdeme zacatek vypisu jednoho CWG
  nMax:=99999;
  //nMax:=38;
  while(sHtml<>'') do begin
    if(nStatorCount>nMax) then begin
{$ifdef DEBUG_HELPER} LDH('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX Preruseno zpracovani prekrocenim poctu nMax='+IntToStr(nMax)); {$endif}
      break;
    end;
    GeoBusyProgress(Trunc(100*((0.+MaxLen-Length(sHtml))/MaxLen)),100);
    //inicializace promennych
    sDiv:=Fetch(sHtml,'</div>'); //najdeme konec bloku
    bCountry:=false;
    if(Pos('<table ',sDiv)>0) then begin //obsahuje tabulku, ne karty, cely blok ignorujeme
      continue;
    end;
    if(Pos('<!-- End of StatorModule',sDiv)>0) then begin //konec divu, zapiseme posledni CWG
      if(sName<>'') then begin
        StatorAddCwg(sName,sId,sGuid,sCountry,sGcCode,sImg,sDate,sNameComment,sGcComment,sDateComment);
      end;
      sName:=''; sId:=''; sGuid:=''; sCountry:=''; sGcCode:=''; sImg:=''; sDate:='';
      sNameComment:=''; sGcComment:=''; sDateComment:='';
      Fetch(sHtml,'<div class="StatorModule"'); //zacatek dalsiho bloku s CWG
      continue;
    end;
    //zjistime o jaky blok se jedna
    if(Pos('id="iCwg_',sDiv)>0) then begin
      if(sName<>'') then begin
        StatorAddCwg(sName,sId,sGuid,sCountry,sGcCode,sImg,sDate,sNameComment,sGcComment,sDateComment);
      end;
      sName:=''; sId:=''; sGuid:=''; sCountry:=''; sGcCode:=''; sImg:=''; sDate:='';
      sNameComment:=''; sGcComment:=''; sDateComment:='';
      Fetch(sDiv,'<div ');  //najdeme zacatek prvniho vnoreneho divu
    end;
    //zjistime, co v bloku je
{$ifdef DEBUG_HELPER} if(nStatorCount>=nMax) then LDH('Import 1 sDiv='+sDiv); {$endif}
    if(Pos('<img src="',sDiv)>0) then begin //obrazek s CWG nebo s vlajkou statu
      s:=StatorGetAttrib(sDiv,'title');       //ziskame titulek obrazku
      if(s<>'') then begin
        //pokud je na zacatku cislice, je to obrazek CWG, jinak je to stat
        if(s[1]>='0') and (s[1]<='9') then begin
          Fetch(s,'.');
          sId:=s;
          sImg:=StatorGetAttrib(sDiv,'src');
{$ifdef DEBUG_HELPER} if(nStatorCount>=nMax) then LDH('Import 1a sId='+sId); {$endif}
          continue;
        end
        else begin
          sCountry:=s;
{$ifdef DEBUG_HELPER} if(nStatorCount>=nMax) then LDH('Import 1b sCountry='+sCountry); {$endif}
          Fetch(sDiv,'>'); //protoze stat a guid nebo coord.info je ve stejnem div, pokracujeme
          bCountry:=true;
        end;
      end;
    end;
{$ifdef DEBUG_HELPER} if(nStatorCount>=nMax) then LDH('Import 2'); {$endif}
    if(Pos('?guid=',sDiv)>0) then begin //guid a jmeno
{$ifdef DEBUG_HELPER} if(nStatorCount>=nMax) then LDH('Import 2a: '+sDiv); {$endif}
      s:=StatorGetAttrib(sDiv,'href');       //ziskame titulek guid
      Fetch(s,'?guid=');
      sGuid:=s;
      sNameComment:=StatorGetAttrib(sDiv,'title');  //ziskame napred komentar u jmena
      Fetch(sDiv,'?guid=');
      sName:=StatorGetText(sDiv);
      Fetch(sDiv,'>');
{$ifdef DEBUG_HELPER} if(nStatorCount>=nMax) then LDH('Import 2b sName='+sName+', sGuid='+sGuid+', sNameComment='+sNameComment); {$endif}
      continue;
    end;
    //pokud je CWG pro kesku, pak je to pres http://coord.info
    if(Pos('//coord.info',sDiv)>0) then begin //GC kod a jmeno
      Fetch(sDiv,'><'); //skocime az na a href="...
      sGuid:=StatorGetAttrib(sDiv,'href');
      sName:=StatorGetText(sDiv);
      //GC kod se nacte normalne
      //Fetch(s,'coord.info/');
      //sGcCode:=s;
{$ifdef DEBUG_HELPER} if(nStatorCount>=nMax) then LDH('Import 2c sName='+sName+', sGuid='+sGuid); {$endif}
      continue;
    end;
    //neni guid, tak jmeno je v tomto divu a pripadne jeho konemtar v <abbr>
    if(bCountry) then begin
      s:=sDiv;
      Fetch(sDiv,'<div');
      if(Pos('<abbr',sDiv)>0) then begin
        Fetch(sDiv,'>');
        sNameComment:=StatorGetAttrib(sDiv,'title'); //pokud tam zustal <abbr>
        Fetch(sDiv,'>');
        sName:=Fetch(sDiv,'</abbr');
        bCountry:=false;
      end;
      if(bCountry) and (Pos('<a href',sDiv)>0) then begin
        Fetch(sDiv,'>');
        sNameComment:=StatorGetAttrib(sDiv,'title'); //pokud tam zustal <abbr>
        Fetch(sDiv,'>');
        sName:=Fetch(sDiv,'</a');
        bCountry:=false;
      end;
      if(bCountry) then begin
        Fetch(sDiv,'>');
        sName:=sDiv;
        bCountry:=false;
      end;
      if(sName='') then ShowMessage('Nepodarilo se ziskat jmeno CWG z'+CRLF+CRLF+s);
{$ifdef DEBUG_HELPER} if(nStatorCount>=nMax) then LDH('Import 2d sName='+sName+', sNameComment='+sNameComment); {$endif}
      continue;
    end;
{$ifdef DEBUG_HELPER} if(nStatorCount>=nMax) then LDH('Import 3'); {$endif}
    if(Pos('?wp=',sDiv)>0) then begin
      s:=StatorGetAttrib(sDiv,'href');       //ziskame titulek guid
      Fetch(s,'?wp=');
      sGcCode:=s;
      sGcComment:=StatorGetAttrib(sDiv,'title');  //ziskame napred komentar u jmena
{$ifdef DEBUG_HELPER} if(nStatorCount>=nMax) then LDH('Import 3b sGcCode='+sGcCode+', sGcComment='+sGcComment); {$endif}
      continue;
    end;
    if(Pos('<abbr title=',sDiv)>0) then begin
      //sDateComment je pred datem v <abbr title=....  //ziskame komentar u kese
      sDateComment:=StatorGetAttrib(sDiv,'title');
      Fetch(sDiv,'<abbr title=');
      Fetch(sDiv,'>');
      sDate:=Fetch(sDiv,'<');
      continue;
    end;
    //regularnim vyrazem zkusime najit datum ve tvaru '>dd.[m]m.yyyy'
    //(na konci stringu, protoze </div> bylo odriznuto)
    s:=RegExSubstitute('>([0-9]{1,2}\.[0-9]{1,2}\.[0-9]{4})$',sDiv,'$1');
    if(s<>'') then sDate:=s;
{$ifdef DEBUG_HELPER} if(nStatorCount>=nMax) then LDH('Import 4 sDate='+sDate); {$endif}
  end;
//{$ifdef DEBUG_HELPER} LDH('Import 5'); {$endif}
  if(sName<>'') then begin
    StatorAddCwg(sName,sId,sGuid,sCountry,sGcCode,sImg,sDate,sNameComment,sGcComment,sDateComment);
  end;
end;

procedure rDatumOnClick(Sender: TObject);
var s:string;
begin
  case(Sender as TRadiobutton) of
  StatorForm_rRucne:   begin
              StatorForm_dDb.Enabled:=true;
            end;
  StatorForm_rDb:      begin //datum databazoveho souboru (posledni zapis do nej)
              StatorForm_dDb.Enabled:=false;
              StatorForm_dDb.Date:=GetFileTime(GetDbPathName());
            end;
  StatorForm_rHtml:      begin //datum importovaneho souboru (posledni zapis do nej)
              StatorForm_dDb.Enabled:=false;
              StatorForm_dDb.Date:=GetFileTime(StatorForm_eStatorFile.Text);
            end;
  StatorForm_rAkt:     begin //datum posledni aktualizace katalogu
              StatorForm_dDb.Enabled:=false;
              StatorForm_dDb.Date:=IntToDate(DDMMRRRRToRRRRMMDD(CwgForm_sDtCatalog.Caption));
            end;
  StatorForm_rZiskane: begin //datum posledniho ziskani CWG
              StatorForm_dDb.Enabled:=false;
              DBOpen();
              s:=CwgDB.GetTableString('SELECT max(DateFound) FROM '+TABLE_FOUND);
              StatorForm_dDb.Date:=IntToDate(s);
              DBClose();
            end;
  end;
end;

procedure butStatorFileOnClick(Sender: TObject);
var sFile:string;
begin
  sFile:=StatorForm_eStatorFile.Text;
  if(OpenDlg('Vyberte importovan soubor', //title
              GetCwgDir(),                //InitDir
              'ofFileMustExist,ofHideReadOnly', //options
              'HTML soubory (*.html, *.htm)|*.html; *.htm|'   //filtr
              +'PHP soubory (*.php)|*.php|'+
              +'Vechny soubory (*.*)|*.*'
              ,sFile)) then
    StatorForm_eStatorFile.Text:=sFile;
end;

procedure butStatorImportOnClick(Sender: TObject);
var sFile:string;
begin
  sFile:=GetCwgDir()+'StatorImport.prt';
  if(FileExists(sFile)) then DeleteFile(sFile);
  hStatorProt:=TFileStream.Create(sFile,fmCreate or fmOpenWrite or fmShareCompat);
  try
    GeoBusyStart();
    DBOpen();
    CwgDB.Start('Stator',''); //zahajime transakci
    nStatorCount:=0;
    nStatorAdd:=0;
    nStatorIgnoreExists:=0;
    nStatorIgnoreOld:=0;
    //pokud maji byt ziskane pred importem smazany, smazeme je
    if(StatorForm_bClear.Checked) then CwgDB.ExecSql('DELETE FROM '+TABLE_FOUND);
    //ziska jmeno souboru
    sFile:=StatorForm_eStatorFile.Text;
{$ifdef DEBUG_HELPER} LDH('Importovany soubor: '+sFile); {$endif}
    StatorLog('Importovany soubor: '+sFile);
    GeoBusyKind(sFile);
    StatorForm.Hide();
    CwgForm.Hide();
    if(StatorForm_rObsah.ItemIndex=0) or (StatorForm_rObsah.ItemIndex=2) then begin
      GeoBusyCaption('Import z karet');
      StatorParseCards(sFile);
    end;
    if(StatorForm_rObsah.ItemIndex=1) or (StatorForm_rObsah.ItemIndex=2) then begin
      GeoBusyCaption('Import z tabulek');
      StatorParseTables(sFile);
    end;
    //pokud je v seznamu neco k pridani, pridame to
    CwgDB.Commit('Stator');   //ukoncime transakci
    CwgForm.Show();
    StatorForm.Show();
    DBClose();
  finally
    hStatorProt.Free();
  end;
  ShowMessage('Pocet zpracovanych CWG: '+IntToStr(nStatorCount)+CRLF
    +'Pocet pridanych do databaze: '+IntToStr(nStatorAdd)+CRLF
    +'Pocet preskocenych katalogovych (uz tam jsou): '+IntToStr(nStatorIgnoreExists)+CRLF
    +'Pocet preskocenych nekatalogovych (stare): '+IntToStr(nStatorIgnoreOld)+CRLF+CRLF
    +'Protokol o importu je v souboru StatorImport.prt'+CRLF
    );
  //pokud bylo neco pridano, nacteme celou databazi znovu
end;