{
  hlavni knihovna funkci pro praci s CWG;
  - funkce polecne vsem zalozkam
  - funkce pro praci s oficialnim ci maxinohovym katalogem a jejich offline zalohou
}
var  CwgDB:TSqliteDatabase;
     aCacheList,aTypeList:TStringList;
     iDbOpen:integer;
     sImportProtokol:string;   //protokol o importu katalogu
     
function GetCwgDir:string;
begin Result:=GEOGET_SCRIPTDIR+'\CwgList2\'; end;

function GetDbPathname:string;
begin Result:=GetCwgDir()+CwgForm_cbDatabase.Items[CwgForm_cbDatabase.ItemIndex]; end;

function GetOfflineDir:string;
begin Result:=GetCwgDir()+'Offline\'; end;

function GetCwgImgPathname(id,ver,category:string):string;
begin Result:=GetOfflineDir()+category+'_'+id+'-'+ver+'.jpg'; end;

function GetCwgImgMissingPathname(category:string):string;
begin
  if(category='SQ') then Result:=GetCwgDir()+'SqMissing.jpg'
  else Result:=GetCwgDir()+'CwgMissing.jpg';
end;

function OldAltPathname:string; //jmeno alternativniho souboru ze stare verze
var s,s1:string;
begin
  Result:='';
  s:=GEOGET_SCRIPTDIR+'\CwgList\CwgList.config.pas';
  if(not FileExists(s)) then exit;
  s1:=FileToString(s);
  Result:=RegexSubstitute('(?is)FILE_ALTERNATIVE\s*=\s*\''(.*?)''\s*;',s1,'$1');
  if(Result<>'') then Result:=RelToAbsFilename(Result,GEOGET_SCRIPTDIR+'\CwgList\');
end;

function DoplnUvozovky(str:string):string;
begin
  if(pos(' ',str)>0) then Result:='"'+str+'"'
  else Result:=str;
end;

//---------------------------------------------
procedure SetActiveTab(tab:TPageControl;name:string);
var i:integer;
begin
  for i:=0 to tab.PageCount-1 do begin
    if(tab.ActivePage.Name=name) then break //i:=tab.PageCount
    else begin
      //1. parametr true ... nasledujici stranka, false ... predchozi
      //2. parametr true ... bere v uvahu jen visible stranky
      tab.SelectNextPage(false,true); //nastavit dalsi stranku
    end;
  end;
end;

procedure SetVisibleTab(tab:TPageControl;name:string; bVisible:boolean);
var i:integer;
begin
{$ifdef DEBUG_HELPER} LDH('xxxxxx SetVisibleTab: '+name); {$endif}
  for i:=0 to tab.PageCount-1 do begin
    if(tab.Pages[i].Name=name) then begin
{$ifdef DEBUG_HELPER} LDH('xxxxxx zmizim stranku '+name); {$endif}
      tab.Pages[i].Visible:=bVisible;
      tab.Pages[i].TabVisible :=bVisible;
    end;
  end;
end;

function UtfToUpAscii(s:string):string;
begin
  Result:=ReplaceString(UtfToGps(s),' ','');
end;

function AnsiToUpAscii(s:string):string;
begin
  Result:=ReplaceString(UtfToGps(AnsiToUtf(s)),' ','');
end;

function MakeCategory(kategorie:string):string; //sjednoti kategorii CWG
begin
  case kategorie of
   //cisla kategorii z https://cwg.gcm.cz/apitest/cwgapi.html#cwgcategory
    '1','cwg','':   Result:='cwg';   //osobni CWG
    '2','cle','le': Result:='cle';   //limitovana edice (kese, skupiny kaceru, ...)
        'ceg','e':  Result:='ceg';   //chybna CWG, nezarazena v katalogu :-)
    '5','swg','s':  Result:='swg';   //osobni CWG pro Slovensko
    '6','sle','sl': Result:='sle';   //limitovana edice (kese, skupiny kaceru, ...)
        'seg','se': Result:='seg';   //chybna CWG, nezarazena v katalogu :-)
    '7','wgp','':   Result:='wgp';   //nova kategorie Wood Geocoin Personal
        'wgo','':   Result:='wgo';   //nova kategorie Wood Geocoin ???
        'wgc','':   Result:='wgc';   //nova kategorie Wood Geocoin ???
    '3','wge','':   Result:='wge';   //nova kategorie Wood Geocoin - extra
   // '8': //Holandska
   // '9': //Nemecka
   '11','mwg','':   Result:='mwg';   //mikro CWG?
   '13','mwp','':   Result:='mwp';   //mikro CWG?
   //'14': //Polska
   //'16': //Australska
   //'17': //Finska
   //'18': //Madarska
   //'19': //Francouzska
   //'20': //Danksa
    else Result:=kategorie;
  end;
end;

function MakeVersionNum(ver:string):Integer;
begin //unifikuje cislo verze a prevede na integer (max 26!!!!)
  Result:=1;
  if(ver<>'') then begin
    if(RegexFind('[a-zA-Z]',ver)) then Result:=Ord(ver[1])-Ord('a')+1 //verze pismenem a-z
    else Result:=StrToInt(ver);
  end;
//{$ifdef DEBUG_HELPER}
//  LDHD('MakeVersionNum(): ver='+ver+', Result='+IntToStr(Result),ldhInfo);
//{$endif}
end;

function ShortSuffixToVer(ver:string):integer;
begin
  Result:=1;
  if(ver>'?') then Result:=54;   //to je maximum
  if(ver>='a') and (ver<='z') then Result:=Ord(ver[1])-Ord('a')+2;
  if(ver>='A') and (ver<='Z') then Result:=Ord(ver[1])-Ord('A')+28;
//{$ifdef DEBUG_HELPER}
//  if(ver>='A') then LDHD('ShortSuffixToVer(): ver='+ver+', Result='+IntToStr(Result),ldhInfo);
//{$endif}
end;

function VerToShortSuffix(iVerze:integer):string;
begin
  Result:='';
  if(iVerze>1) and (iVerze<=27) then Result:=Chr(iVerze-2+Ord('a'));
  if(iVerze>27) and (iVerze<=53) then Result:=Chr(iVerze-28+Ord('A'));
  if(iVerze>53) then Result:='?';
{$ifdef DEBUG_HELPER}
 // if(iVerze>9) then LDH('VerToShortSuffix(): iVerze='+IntToStr(iVerze)+', Result='+Result);
{$endif}
end;

function VerToSuffix(iVerze:integer):string;
begin
  Result:='';
  if(iVerze>1) then Result:='_v'+VerToShortSuffix(iVerze);
end;

function JpgToVer(jpg:string):integer;
var s:string;
begin
  Result:=1;
  s:=RegExSubstitute('(?i)[0-9]+([a-z]{0,1}).*',jpg,'$1');
  if(s<>'') then begin
    Result:=Ord(s[1])-Ord('a')+1;
  end;
end;
///////////////////////// Vytvoreni tabulek v databazi /////////////////////////
function SettingsParam(ParamName,Value:string):boolean;
//var s:string;
begin
  Result:=false;
  if(CwgDB<>nil) then begin
    Result:=true;
    //{$ifdef DEBUG_HELPER} LDHD('SettingsParam(): nastavuji '+ParamName+'='+Value,ldhInfo); {$endif}
    CwgDB.AddParamText(':id',Value);
    CwgDB.AddParamText(':name',ParamName);
    CwgDB.ExecSQL('UPDATE '+TABLE_SETTINGS+' SET value=:id where ParamName=:name');
    //pokud se nepodari, mozna bude potreba misto UPDATE pouzit INSERT
    //tady asi bude problem v pripade, ze bude nastavovana hodnota '' protoze pak nepoznam,
    //zda se nastavit podarilo nebo ne
    if(Value<>CwgDB.GetTableString('SELECT Value FROM '+TABLE_SETTINGS+' WHERE ParamName='''+ParamName+'''')) then begin
      //{$ifdef DEBUG_HELPER} LDHD('SettingsParam(): doplnuji '+ParamName+'='+Value,ldhInfo); {$endif}
      CwgDB.ExecSQL('INSERT INTO '+TABLE_SETTINGS+' (ParamName,Value) VALUES ('''+ParamName+''','''+Value+''')');
    end;
  end
  else ShowMessage('ERR: SettingsParam(): neni otevrena CwgDB!');
end;

procedure SetCountryIfNeed;
begin
  //vyplni stat u ziskanych katalogovych CWG, pokud jej vyplneny nemaji
  //(predpoklada otevrenou databazi)
  CwgDB.ExecSQL('UPDATE '+TABLE_FOUND+' SET Country='
    +'(SELECT Country FROM '+TABLE_CATALOG+' WHERE '
    +TABLE_CATALOG+'.Category||'+TABLE_CATALOG+'.Id='+TABLE_FOUND+'.Category||'+TABLE_FOUND+'.id) '
    +'WHERE id>0 AND (Country="" OR Country is NULL)');
end;

procedure CheckDataVersion; //kontrola verze databazove struktury a pripadne jeji modifikace na verzi aktualni
var sDbVer:string;
    i,j:integer;
    tab:TSQLiteTable;
begin
  //nacteme cislo verze databaze
  sDbVer:=CwgDB.GetTableString('SELECT Value FROM '+TABLE_SETTINGS+' WHERE ParamName='''+TABLE_SETTINGS_NAME_DBVERSION+'''');
  //{$ifdef DEBUG_HELPER} LDHD('CheckDataVersion(): databaze verze '+sDbVer,ldhInfo); {$endif}
  if(sDbVer='') then sDbVer:='1';
  for i:=StrToInt(sDbVer) to StrToInt(DB_VERSION) do begin
   {$ifdef DEBUG_HELPER} LDH('CheckDataVersion(): test verze '+IntToStr(i)); {$endif}
    case i of
    1: begin //prechod z verze 1 na 2, pridame sloupce do tabulky MyCWG
         {$ifdef DEBUG_HELPER} LDHD('CheckDataVersion(): konverze DB ver 1=>2',ldhInfo); {$endif}
         //{$ifdef DEBUG_HELPER} LDHD('CheckDataVersion(): prechod na tabulku verze 2',ldhInfo); {$endif}
         CwgDB.ExecSQL('ALTER TABLE '+TABLE_FOUND+' ADD COLUMN GcmData VARCHAR2');
         CwgDB.ExecSQL('ALTER TABLE '+TABLE_FOUND+' ADD COLUMN SvetGcData VARCHAR2');
         SettingsParam(TABLE_SETTINGS_NAME_DBVERSION,'2'); //nastavime nasledujici cislo verze
       end;
    2: begin //prechod z verze 2 na 3, pridame sloupec do tabulky CatCWG
         {$ifdef DEBUG_HELPER} LDHD('CheckDataVersion(): konverze DB ver 2=>3',ldhInfo); {$endif}
         //{$ifdef DEBUG_HELPER} LDHD('CheckDataVersion(): prechod na tabulku verze 3',ldhInfo); {$endif}
         CwgDB.ExecSQL('ALTER TABLE '+TABLE_CATALOG+' ADD COLUMN Zarazeno VARCHAR2');
         SettingsParam(TABLE_SETTINGS_NAME_DBVERSION,'3'); //nastavime nasledujici cislo verze
       end;
    3: begin //prechod z verze 3 na 4, pridame sloupec do tabulky CatCWG
         {$ifdef DEBUG_HELPER} LDHD('CheckDataVersion(): konverze DB ver 3=>4',ldhInfo); {$endif}
         //{$ifdef DEBUG_HELPER} LDHD('CheckDataVersion(): prechod na tabulku verze 3',ldhInfo); {$endif}
         CwgDB.ExecSQL('ALTER TABLE '+TABLE_CATALOG+' ADD COLUMN Country VARCHAR2');
         SettingsParam(TABLE_SETTINGS_NAME_DBVERSION,'4'); //nastavime nasledujici cislo verze
       end;
    4: begin //prechod z verze 4 na 5, pridame sloupec do tabulky MyCWG
         {$ifdef DEBUG_HELPER} LDHD('CheckDataVersion(): konverze DB ver 4=>5',ldhInfo); {$endif}
         //{$ifdef DEBUG_HELPER} LDHD('CheckDataVersion(): prechod na tabulku verze 3',ldhInfo); {$endif}
         CwgDB.ExecSQL('ALTER TABLE '+TABLE_FOUND+' ADD COLUMN Country VARCHAR2');
         SetCountryIfNeed();  //vyplnit sloupec u CWG z katalogu
         SettingsParam(TABLE_SETTINGS_NAME_DBVERSION,'5'); //nastavime nasledujici cislo verze
         ShowMessage('WARN: Do katalogu CWG byla doplnena informace o statu.'+CRLF
           +'Doporucuji doplnit tuto informaci u ziskanych CWG,'+CRLF
           +'ktera v katalogu nejsou.');
       end;
     5: begin //prechod z verze 5 na 6, kontroly sloupcu, pridani indexu
          //kvuli chybe pri vytvareni nove databaze verze 5 nebyl vytvoren
          //sloupec MyCwg.Country. Zkontrolujeme tedy, zda sloupec existuje
          tab:=CwgDB.GetTable('PRAGMA table_info("'+TABLE_FOUND+'")',false);
          j:=0; //sloupec neexistuje
          try
            while not tab.eof do begin
              if(UpperCase(tab.FieldAsString(1))='COUNTRY') then begin
                j:=1;
                break;
              end;
              tab.next;                   // skok na dalsi
            end;
            //pokud sloupec neni, vytvorime jej
            if(j=0) then begin
               {$ifdef DEBUG_HELPER} LDHD('CheckDataVersion(): konverze DB ver 5=>5+Country Column',ldhInfo); {$endif}
               CwgDB.ExecSQL('ALTER TABLE '+TABLE_FOUND+' ADD COLUMN Country VARCHAR2');
               SettingsParam(TABLE_SETTINGS_NAME_DBVERSION,'5'); //nastavime nasledujici cislo verze
               SetCountryIfNeed();                               //vyplnit sloupec u CWG z katalogu
               ShowMessage('WARN: Do katalogu CWG byla doplnena informace o statu.'+CRLF
                 +'Doporucuji doplnit tuto informaci u ziskanych CWG,'+CRLF
                 +'ktera v katalogu nejsou.');
            end;
          finally
            if(tab<>nil) then tab.Free();
          end;
          {$ifdef DEBUG_HELPER} LDHD('CheckDataVersion(): konverze DB ver 5=>6',ldhInfo); {$endif}
          CwgDB.ExecSQL('CREATE INDEX [IdxCat_NameUpAsciiIdCatVer] ON [CatCWG] (NameUpAscii||Id||Category||Version);');
          CwgDB.ExecSQL('CREATE INDEX [IdxMy_NameUpAsciiIdCatVer] ON [MyCWG] (NameUpAscii||Id||Category||Version);');
          SettingsParam(TABLE_SETTINGS_NAME_DBVERSION,'6'); //nastavime nasledujici cislo verze
        end;
    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    //pridani novych sloupcu a podobne upravy je treba udelat i pri vytvareni
    //databazovych tabulek v rutine DBCreateTable(name:string)
    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    end;
    //otestujeme existenci indexu (od verze
  end;
  {$ifdef DEBUG_HELPER} LDH('CheckDataVersion(): konec'); {$endif}
end;

function DBCreateTable(name:string):boolean;
begin
  Result:=false;
  {$ifdef DEBUG_HELPER} LDH('DBCreateTable(): vytvarim tabulku '+name
    +' (DB ver '+DB_VERSION+')'); {$endif}
  case uppercase(name) of
  uppercase(TABLE_CATALOG): begin
            CwgDB.ExecSQL(
              'CREATE TABLE [CatCWG] ('+CRLF
              +'  [NameUpAscii] VARCHAR2 NOT NULL ON CONFLICT FAIL COLLATE NOCASE'+CRLF
              +'  ,[Name] VARCHAR2 NOT NULL ON CONFLICT FAIL COLLATE NOCASE'+CRLF
              +'  ,[Id] INT NOT NULL ON CONFLICT FAIL'+CRLF
              +'  ,[Zarazeno] VARCHAR2'+CRLF
              +'  ,[Category] VARCHAR2 NOT NULL ON CONFLICT FAIL'+CRLF
              +'  ,[Version] INT NOT NULL ON CONFLICT FAIL DEFAULT (1)'+CRLF
              +'  ,[Jpg] VARCHAR2'+CRLF
              +'  ,[Country] VARCHAR2'+CRLF
              +'  ,[UserGuid] VARCHAR2'+CRLF
              +'  ,[CacheID] VARCHAR2 COLLATE NOCASE'+CRLF
              +'  ,[Comment] VARCHAR2'+CRLF
              +'  ,[Catalog] VARCHAR2'+CRLF
              +'  ,CONSTRAINT [] PRIMARY KEY ([Category], [Id], [Version]));'
              );
            CwgDB.ExecSQL('CREATE INDEX [IdxCat_NameUpAscii] ON [CatCWG] ([NameUpAscii] COLLATE NOCASE);');
            CwgDB.ExecSQL('CREATE INDEX [IdxCat_NameUpAsciiIdCatVer] ON [CatCWG] (NameUpAscii||Id||Category||Version);');
            Result:=true;
            end;
  uppercase(TABLE_SETTINGS): begin
            CwgDB.ExecSQL(
              'CREATE TABLE [Settings] ('+CRLF
              +'  [ParamName] VARCHAR2 NOT NULL ON CONFLICT FAIL COLLATE NOCASE,'+CRLF
              +'  [Value] VARCHAR2 NOT NULL ON CONFLICT FAIL);'
              );
            CwgDB.ExecSQL('CREATE UNIQUE INDEX [IdxSettingsName] ON [Settings] ([ParamName]);');
            CwgDb.ExecSQL('INSERT INTO '+TABLE_SETTINGS+' (ParamName,Value) VALUES ('''+TABLE_SETTINGS_NAME_LASTID+''',''-1'');');
            CwgDb.ExecSQL('INSERT INTO '+TABLE_SETTINGS+' (ParamName,Value) VALUES ('''+TABLE_SETTINGS_NAME_DTUPDATE
              +''','''+DateToInt(now)+''');');
            end;
  uppercase(TABLE_FOUND): begin
            CwgDB.ExecSQL(
              'CREATE TABLE [MyCWG] ('+CRLF
                +'  [NameUpAscii] VARCHAR2 NOT NULL ON CONFLICT FAIL COLLATE NOCASE'+CRLF
                +'  ,[Name] VARCHAR2 NOT NULL ON CONFLICT FAIL COLLATE NOCASE'+CRLF
                +'  ,[Id] INT DEFAULT (-1)'+CRLF
                +'  ,[Category] VARCHAR2 NOT NULL ON CONFLICT FAIL'+CRLF
                +'  ,[Version] INT NOT NULL ON CONFLICT FAIL DEFAULT (1)'+CRLF
                +'  ,[DateFound] VARCHAR2'+CRLF
                +'  ,[IsCacheFound] INT(1)'+CRLF
                +'  ,[Cnt] INT'+CRLF
                +'  ,[CacheID] VARCHAR2 COLLATE NOCASE'+CRLF
                +'  ,[Img] VARCHAR2'+CRLF
                +'  ,[GUID] VARCHAR2'+CRLF
                +'  ,[TabGroup] VARCHAR2'+CRLF
                +'  ,[CommentName] VARCHAR2'+CRLF
                +'  ,[CommentDate] VARCHAR2'+CRLF
                +'  ,[CommentCacheId] VARCHAR2'+CRLF
                +'  ,[CommentImg] VARCHAR2'+CRLF
                +'  ,[GcmData] VARCHAR2'+CRLF
                +'  ,[SvetGcData] VARCHAR2'+CRLF
                +'  ,[Country] VARCHAR2'+CRLF
                +'  , CONSTRAINT [autoindex_MyCWG_1] PRIMARY KEY ([Category], [Id], [Version])'+CRLF
                +')');
            CwgDB.ExecSQL('CREATE INDEX [IdxMy_NameUpAscii] ON [MyCWG] ([NameUpAscii] COLLATE NOCASE)');
            CwgDB.ExecSQL('CREATE INDEX [IdxMy_NameUpAsciiIdCatVer] ON [MyCWG] (NameUpAscii||Id||Category||Version);');
            Result:=true;
            end;
  else ShowMessage('ERR: chybne jmeno tabulky ("'+name+'") pro jeji vytvoreni v databazi CWG.');
  end;
end;
///////////////////////////// prace s databazi CWG /////////////////////////////
function DBOpen:boolean;    //vytvori databazi s tabulkami CatCWG a MyCWG
var b:boolean;
begin
  if(CwgDB=nil) then begin
{$ifdef DEBUG_HELPER} LDH('DBOpen(): otviram databazi '+GetDbPathName()); {$endif}
    b:=FileExists(GetDbPathName());
    try
      if(not b) then begin
        {$ifdef DEBUG_HELPER} LDHD('DBOpen(): vytvarim databazi '+GetDbPathName(),ldhInfo); {$endif}
        //ShowMessage('ERR: neexistuje databaze CWG, vytvarim novou ...');
        CwgDB:=TSqliteDatabase.Create(GetDbPathName());
        DBCreateTable(TABLE_CATALOG);
        DBCreateTable(TABLE_FOUND);
        DBCreateTable(TABLE_SETTINGS);
        SettingsParam(TABLE_SETTINGS_NAME_DBVERSION,DB_VERSION); //nastavime cislo verze do databaze
      end
      else begin
        CwgDB:=TSqliteDatabase.Create(GetDbPathName());
        //zkontrolovat verzi databaze a pripadne ji modifikovat na aktualni
        CheckDataVersion();
      end;
    finally
    end;
  end;
  Result:=(CwgDB<>nil);
  if(CwgDB<>nil) then begin
    Inc(iDbOpen);
    CwgDB.AddSystemCollate(); //razeni podle ceskych pravidel (pokud jsou ceska win)
  end;
end;

procedure DBClose;
begin
{$ifdef DEBUG_HELPER} LDH('DBOpen(): zaviram databazi, pocet otevreni='+IntToStr(iDbOpen)); {$endif}
  Dec(iDbOpen);
  if(iDbOpen=0) then begin
    if(CwgDB<>nil) then CwgDB.Free();
    CwgDB:=nil;
  end;
end;

function UpdateLastId(bUpdate:boolean):Integer; //aktualizuje tabulku s poslednim ID pro
begin
  Result:=-1;
  //databaze musi byt otevrena, pokud neni, otevreme ji
  DBOpen();
  Result:=StrToInt(CwgDB.GetTableString('SELECT Value FROM '+TABLE_SETTINGS+' WHERE ParamName='''+TABLE_SETTINGS_NAME_LASTID+''''));
  if(bUpdate) then begin
    Result:=Result-1;
    SettingsParam(TABLE_SETTINGS_NAME_LASTID,IntToStr(Result));
  end;
  DBClose();
end;

function DDMMRRRRToDate(s:string):TDateTime; //konverze D.M.RRRR na datum
var d,m:string;
begin
  d:=fetch(s,'.'); m:=fetch(s,'.');
  if(length(s)<2) then d:='0'+d;
  if(length(m)<2) then d:='0'+d;
  Result:=IntToDate(s+m+d);
end;

function DDMMRRRRToRRRRMMDD(s:string):string; //konverze D.M.RRRR na RRRRMMDD
var d,m:string;
begin
  d:=fetch(s,'.'); m:=fetch(s,'.');
  //zkontrolujeme, zda nahodou neni uz spravny format
  if(m='') then Result:=d
  else begin
    if(length(s)<2) then d:='0'+d;
    if(length(m)<2) then m:='0'+m;
    Result:=s+m+d;
  end;
end;

//normalizuje format zarazeni do katalogu z ruznych tvaru do formatu RRRRMMDD
//zdrojove formaty: dd.mm.rrrr  (SvetGC <since>)
//                  mm.rrrr
//                  mesic_rimskymi.rrrr (SvetGC <since>)
//                  rrrr-mm-dd hh:mm:ss (GeoGadget <zarazeno>)
function Zarazeno2Format(str:string):string;
begin
  Result:=str;
  //napred plny format datum+cas (GeoGadget)
  if(pos('-',str)>0) then begin
    str:=ReplaceString(str,'-','');
    Result:=Fetch(str,' ');
  end
  else begin //zkusime plne datum ze SvetGC
    //prevedeme mesic rimskymi cislicemi na plne datum (bereme stred mesice)
    str:=ReplaceString(str,'XII','15.12');
    str:=ReplaceString(str,'XI','15.11');
    str:=ReplaceString(str,'X','15.10');
    str:=ReplaceString(str,'IX','15.09');
    str:=ReplaceString(str,'VIII','15.08');
    str:=ReplaceString(str,'VII','15.07');
    str:=ReplaceString(str,'VI','15.06');
    str:=ReplaceString(str,'V','15.05');
    str:=ReplaceString(str,'IV','15.04');
    str:=ReplaceString(str,'III','15.03');
    str:=ReplaceString(str,'II','15.02');
    str:=ReplaceString(str,'I','15.01');
    Result:=DDMMRRRRToRRRRMMDD(str);
  end;
end;

function DBAddCwg(Name,Id,Version,Category,Country,Jpg,UserGuid,CacheID,Comment,Catalog,Zarazeno:string):boolean;
var i,iVer:Integer;
    s,sCat,sZar:string;
begin
  Result:=false;
  if(Name='') then exit; //pokud neni nick (XML od GeoGadget takove ma), ignorujeme
  //- kontroluje pri pridani duplicitu (podle unikatniho klice)
  //- pokud tam jiz pridavany je, kontoluje, zda puvodni jpg neni prazdne
  //  nebo xxx00000.jpg, pripadne doplni nejaky chybejici udaj, pokud tam neni
  //- pokud tam jeste neni, prida CWG
  iVer:=MakeVersionNum(Version);
  sCat:=MakeCategory(Category);
  sZar:=Zarazeno2Format(Zarazeno);
  try
    if(CwgDB=nil) then begin ShowMessage('ERR: DB neni otevrena.'); GeoAbort(); end;
    if(id='') then begin
      //chybu hlasime jen pokud neni katalog 'G, kde je toto bezne (ale chybne)
      if(Catalog<>'G') then
        ShowMessage('ERR: prazdne ID (cislo) CWG.'+CRLF+CRLF
          +'Name: '+UtfToAnsi(Name)+CRLF
          +'ID: '+UtfToAnsi(Id)+CRLF
          +'Version: '+UtfToAnsi(Version)+CRLF
          +'Category: '+UtfToAnsi(Category)+CRLF
          +'Stat: '+UtfToAnsi(Country)+CRLF
          +'Jpg: '+UtfToAnsi(Jpg)+CRLF
          +'UserGuid: '+UtfToAnsi(USerGuid)+CRLF
          +'CacheID: '+UtfToAnsi(CacheID)+CRLF
          +'Comment: '+UtfToAnsi(Comment)+CRLF
          +'Catalog: '+UtfToAnsi(Catalog)+CRLF
          +'Zarazeno: '+Zarazeno+'('+sZar+')'+CRLF
        );
      exit;
    end;
    sCat:=Trim(sCat);
    Name:=Trim(name);
    CacheID:=Trim(CacheID);
    Comment:=Trim(Comment);
    Catalog:=Trim(Catalog);
    jpg:=Trim(jpg);
    UserGuid:=Trim(UserGuid);
    //zkontrolujeme, zda guid neobsahuje cele url, pokud ano, vyhodime jej
    //(v tom pripade obsahuje i mezery kolem pomlcek v guid, ty vyhodime take)
    UserGuid:=ReplaceString(UserGuid,' ',''); //vyhodime mezery
    i:=Pos('?guid=',UserGuid);
    if(i>0) then UserGuid:=Copy(UserGuid,i+6,Length(UserGuid));
    CwgDB.AddParamInt(':id',StrToInt(Id));
    CwgDB.AddParamInt(':ver',iVer);
    CwgDB.AddParamText(':cat',sCat);
    i:=CwgDB.GetTableValue('SELECT count(ID) FROM '+TABLE_CATALOG+' where ID=:id and VERSION=:ver and CATEGORY=:cat');
    if(i=0) then begin //pridame CWG
      CwgDB.AddParamText(':nameUp',AnsiToUpAscii(Name)+VerToSuffix(iVer));
      CwgDB.AddParamText(':name',AnsiToUtf(Name));  //Name a Comment prevadime na UTF-8!!!
      CwgDB.AddParamInt(':id',StrToInt(Id));
      CwgDB.AddParamText(':cat',sCat);
      CwgDB.AddParamText(':country',Country);
      CwgDB.AddParamInt(':ver',iVer);
      CwgDB.AddParamText(':jpg',jpg);
      CwgDB.AddParamText(':guid',UserGuid);
      CwgDB.AddParamText(':cache',CacheID);
      CwgDB.AddParamText(':comment',AnsiToUtf(Comment));
      CwgDB.AddParamText(':catalog',AnsiToUtf(Catalog));
      CwgDB.AddParamText(':zar',sZar);
      s:='INSERT INTO '+TABLE_CATALOG
        +' (NameUpAscii, Name, Id, Category, Version, Country, Jpg, UserGuid, CacheID, Comment, Catalog, Zarazeno) '
        +' VALUES (:nameUp, :name, :id, :cat, :ver, :country, :jpg, :guid, :cache, :comment, :catalog, :zar)';
      CwgDB.ExecSQL(s);
      Result:=true; //pridano
    end
    else begin         //zkontrolujeme, zda je vse stejne nastaveno a nic nechybi
      //duplicitu nehlasime, protoze pri zpracovani druheho katalogu je pro vetsinu CWG
      //ShowMessage('WARN: duplicita pro: '+Name+CRLF+'id='+id+CRLF+'verze='+IntToStr(iver));
      CwgDB.AddParamInt(':id',StrToInt(Id));
      CwgDB.AddParamInt(':ver',iVer);
      CwgDB.AddParamText(':cat',sCat);
      s:=UtfToAnsi(CwgDB.GetTableString('SELECT name FROM '+TABLE_CATALOG+' where ID=:id and VERSION=:ver and Category=:cat'));
      if((StrToInt(Id)<1) or (Name='')) then begin
        sImportProtokol:=sImportProtokol+'ERR: chybny vstup ID='+Id+', Categorie='+sCat+', verze '+IntToStr(iVer)
          +'    importovane jmeno: '+Name+CRLF
          ;
      end;
      if(s<>Name) and (StrToInt(Id)<>0) then begin
        sImportProtokol:=sImportProtokol+'ERR: konflikt ID='+Id+', Categorie='+sCat+', verze '+IntToStr(iVer)+CRLF
          +'    jmeno v databazi: '+s+CRLF
          +'    importovane jmeno: '+Name+CRLF
          ;
      end;
      CwgDB.AddParamInt(':id',StrToInt(Id));
      CwgDB.AddParamInt(':ver',iVer);
      CwgDB.AddParamText(':cat',sCat);
      s:=CwgDB.GetTableString('SELECT JPG FROM '+TABLE_CATALOG+' where ID=:id and VERSION=:ver and Category=:cat');
      if(s<>Jpg) then begin
        if((s='') or (s='cwg00000.jpg')) then begin
          CwgDB.AddParamInt(':id',StrToInt(Id));
          CwgDB.AddParamInt(':ver',iVer);
          CwgDB.AddParamText(':jpg',jpg);
          CwgDB.AddParamText(':cat',sCat);
          CwgDB.ExecSQL('UPDATE '+TABLE_CATALOG+' SET JPG=:jpg where ID=:id and VERSION=:ver and CATEGORY='':cat''');
        end;
      end;
      CwgDB.AddParamInt(':id',StrToInt(Id));
      CwgDB.AddParamInt(':ver',iVer);
      CwgDB.AddParamText(':cat',sCat);
      s:=CwgDB.GetTableString('SELECT Zarazeno FROM '+TABLE_CATALOG+' where ID=:id and VERSION=:ver and Category=:cat');
      if(s<>sZar) and (s<>'') then begin //aktualizujeme datum
        CwgDB.AddParamInt(':id',StrToInt(Id));
        CwgDB.AddParamInt(':ver',iVer);
        CwgDB.AddParamText(':cat',sCat);
        CwgDB.AddParamText(':zar',sZar);
        CwgDB.ExecSQL('UPDATE '+TABLE_CATALOG+' SET Zarazeno=:zar where ID=:id and VERSION=:ver and CATEGORY='':cat''');
      end;
    end;
  finally
  end;
end;

///////////////////////////// prace s databazi CWG /////////////////////////////

//nacte XML soubor ze serveru a parsuje ho
function ReadXml(sPathXml,BusyCaption,sCatalog:string):TJclSimpleXML;
var  s,sFile:string;
begin
  sFile:=GetOfflineDir()+'Cwg_'+sCatalog+'.xml';
//##  sFile:=GetOfflineDir()+'Cwg_'+sCatalog+'_pok.xml';
  GeoBusyStart();
  GeoBusyCaption(BusyCaption);
  GeoBusyKind('Nacitani ze serveru');
  s:=''; //aby se zapsal prazdny soubor, pokud bude chyba pri cteni z webu
  if(not HttpAsk('GET',sPathXml,'','',s))then begin
    ShowMessage('ERR: Chyba cteni z '+sPathXml);
  end;
  StringToFile(s,sFile);

  GeoBusyKind('Parsovani');
  Result:=TJclSimpleXML.Create();
  try
    //seAuto neni moc spolehlive, u kratkych souboru (zrejme) si to vymysli
    //a vysledek neni vracen v ANSI, ale v UTF8 lepe by bylo asi vstupni
    //kodovani predepsat seUTF8
    Result.loadfromfile(sFile,seAuto,0);
  finally
    //DeleteFile(sFile);
  end;
end;

function ParseXML(Xml:TJclSimpleXML;BusyCaption:string):string; //vraci '' pri OK, jinak chybu
var  ele: TJclSimpleXMLElem;
     n,j: integer;
     bErr:boolean;
     id,idVer,id_k,guid,jmeno,gc,jpg,jpg_oficialni,img,vyroba,verze,kategorie,svetgc
     ,koment,od,katalog,country,sTag,tagy: string;
     aCiselniky:TStringList;

begin
  { seznam TAGu v XML souborech jednotlivych serveru
    cislo           - S G (cislo CWG v katalogu, bez uvodnich nul)
    fotka           - S - (jmeno souboru s obrazkem, bez cesty)
    gc              M - - (ID kese, ktere je prirazeno CWG, pak neni naplneno guid)
    guid            M - G (guid uzivatele, kteremu CWG patri)
    id              M - - (cislo CWG v katalogu, bez uvodnich nul)
    id_katalog      M - G (poradove cislo CWG v katalogu s verzi ("52-2"),
                          G: u SQ neni za pomlckou verze, ale cosi jineho,
                             u CWG jsem to zatim nepozoroval
    img             - - G (URL obrazku na GeoGadget serveru)
    jmeno           M S G (jmeno CWG)
    jpg_oficialni   M - G (jmeno souboru s obrazkem bez cesty)
    kategorie       - S G (S-cislo kategorie, G-3 pismena kategorie
    stat            - - G (zkratka statu)
    komentar        - S G (S-pricina nezarazeni do katalogu, G-rozdil od nicku, ...)
    odkaz           - S G (S-uplne URL guidu uzivatele nebo kese, G-URL odkazu na webovou stranku kese,...)
    since           - S - (mesic zarazeni do katalogu)
    svetgc          - S - (URL uzivatele na svetgc)
    verze           - S G (cislo verze CWG)
    vyroba          M - - (jmeno vyrobce)
    zarazeno        - - G (datum a cas zarazeni do katalogu)
    tagy            - - G (tagy stat, kategore, a dalsi???)  prozatim neni zpracovano

    xml od GeoGadget
      - id a id_katalogu obsahuje i pismena! (co s tim?)
  }
  bErr:=false;
  Result:='';
  //Result:='XXXX';  exit;
  GeoBusyStart();
  GeoBusyCaption(BusyCaption);
  GeoBusyKind('Parsovani');
  aCiselniky:=TStringList.Create();
  try
    //ciselnik je serazeny a ignorujeme duplicity
    aCiselniky.Sorted:=true;
    //aCiselniky.CaseSensitive:=true;
    aCiselniky.Duplicates:=dupIgnore;
    for n:=0 to XML.Root.Items.count-1 do begin
      GeoBusyProgress(n,XML.Root.Items.count);
      ele:=XML.Root.Items[n];
      //        maxinohuv root        oficialni root        GeoGadget
      if (ele.name='cwg') or (ele.name='cwgkatalog' ) {or (ele.name='cwgkatalog' )}then
        begin
        id:=''; idVer:=''; id_k:=''; guid:=''; jmeno:=''; gc:='';
        jpg:=''; jpg_oficialni:='';
        img:=''; vyroba:=''; country:=''; tagy:='';
        verze:=''; kategorie:=''; svetgc:=''; koment:=''; od:=''; katalog:='';
        for j:=0 to ele.Items.count-1 do begin
          if(GeoBusyTest()) then break;
          case (ele.Items[j].name) of
          //---spolecne
          'jmeno':      jmeno:=ele.Items[j].Value;
          'guid':       //pro GUID doplnime tak, aby bylo platne URL
                        if (ele.Items[j].Value<>'') then guid:=HTTP_GUID+ele.Items[j].Value;
          //---Maxinoha
          'id':         id:=ele.Items[j].Value;   //id maxinohy, je nezajimave
                        //pro GC doplnime tak, aby bylo platne URL
          'gc':         if (ele.Items[j].Value<>'') then guid:=HTTP_INFO+ele.Items[j].Value;
          'jpg_oficialni': jpg_oficialni:=IMGDIR_MAXINOHA+ele.Items[j].Value;
          'vyroba':     begin vyroba:=ele.Items[j].Value; katalog:='M'; end;
          //---Maxinoha, GeoGadget
          'id_katalog': id_k:=ele.Items[j].Value;
          //---nemo, GeoGadget
          'cislo':      id:=ele.Items[j].Value;
          'verze':      verze:=ele.Items[j].Value;
          'kategorie':  kategorie:=MakeCategory(ele.Items[j].Value);
          'odkaz':      if(ele.Items[j].Value<>'') then guid:=ele.Items[j].Value;  //tady je cele URL
          'komentar':   koment:=ele.Items[j].Value;
          //---nemo
          'svetgc':     begin svetgc:=ele.Items[j].Value; katalog:='S'; end;
          'since':      od:=ele.Items[j].Value;
          'fotka':      jpg:=IMGDIR_SVETGC+ele.Items[j].Value;
          //---GeoGadget
          'img':        begin img:=ele.Items[j].Value; katalog:='G'; end;
          'zarazeno':   od:=ele.Items[j].Value;
          'zeme':       country:=ele.Items[j].Value;
          'tagy':       tagy:=ele.Items[j].Value;   //prozatim neni dal zpracovano, jen do ciselniku
          else begin
                 ShowMessage('V XML souboru s katalogem byl nalezen neznamy element:'+CRLF
                   +'<'+ele.Items[j].name+'>'+CRLF+CRLF
                   +'Zpracovani bude preruseno pro chybny format XML dat.');
                 bErr:=true;
                 Result:='Unknown XML element';
                 break;
               end;
          end;
          if(bErr) then break;
        end;
        if(bErr) then break;
        //---------------------------- upravit nactene informace do naseho tvaru
        if(katalog='M') then begin  //z maxinohova katalogu ziskame potrebne informace parsovanim hodnot
          //if(id_k='s124') then ShowMessage('YYYY 1:'+jmeno+CRLF+id+CRLF+verze+CRLF+kategorie);
          jpg:=jpg_oficialni;
          id:=RegexSubstitute('([0-9]+)[-]*[0-9]*',id_k,'$1');
          verze:=RegexSubstitute('[0-9]*[-]([0-9]+)',id_k,'$1');
          idVer:=verze;
          kategorie:=RegexReplace('[0-9].*',id_k,'',true);
          //kategorie:=copy(id_k,1,1); //pozor, neda to jen pismena! CWG nemam na zacatku 'c', ale jen cislo ID
          //if(id_k='s124') then ShowMessage('YYYY 2:'+jmeno+CRLF+'id='+id+CRLF+'verze='+verze+CRLF+'kategorie='+kategorie);
        end;
        if(katalog='G') then begin
          if(jpg='') and (img<>'') then jpg:=img
          else jpg:=IMGDIR_SVETGC+jpg_oficialni;
          id:=RegexSubstitute('([0-9]+)[-]*[0-9]*',id_k,'$1');
          idVer:=RegexSubstitute('[0-9]*[-]([0-9]+)',id_k,'$1');
          if(idVer='') then idVer:='1';
{$ifdef DEBUG_HELPER}
          if(idVer<>verze) then begin
            LDHE('INFO: nesoulad mezi verzi a cislem za pomckou v ID: (sVer='
              +verze+', idVer='+idVer+')');
            //exit;
          end;
{$endif}
          verze:=idVer;
          //obrazek je nekdy s plnou cestou, nekdy relativni, pak zrejme vzdy
          //http://www.geokatalog.cz/
          if(Pos('http:',jpg)<1) then jpg:='http://www.geokatalog.cz/'+jpg;
        end;
        //if(RegexFind('^.*/.*guid=',guid)) then begin guid:=RegexReplace('^.*/.*guid=',guid,'',true); gc:=''; end;
        //coord.info udava jak GC kese, tak profil, odhadujeme podle kategorie, o co jde
        //if(RegexFind('^.*/coord.info/',guid)) then begin
        //  if((kategorie='cle') or (kategorie='sle')) then begin
        //    gc:=RegexReplace('^.*/',guid,'',true);
        //    guid:='';
        //  end else begin
        //    guid:=RegexReplace('^.*/',guid,'',true);
        //    gc:='';
        //  end;
        //end;
        //if(RegexFind('^.*/.*wp=',guid)) then begin gc:=RegexReplace('^.*/.*wp=',guid,'',true); guid:=''; end;
        //pridame CWG do nasi databaze
        //if(id='124') then ShowMessage('IIII :'+jmeno+CRLF+id+CRLF+verze+CRLF+kategorie);
        DBAddCwg(jmeno,id,verze,kategorie,country,trim(jpg),trim(guid),trim(gc),trim(koment),katalog,od);
        aCiselniky.Add('cat:'+kategorie);
        aCiselniky.Add('country:'+country);
        while(tagy<>'') do begin  //pridame vsechny tagy, ktere CWG ma, do ciselniku
          sTag:=Fetch(tagy,':');
          aCiselniky.Add('tagy:'+sTag);
        end;
      end; //if root
    end;  //for n:=0
    if(katalog='G') then katalog:='GeoGadget';
    if(katalog='S') then katalog:='SvetCwg';
    if(katalog='M') then katalog:='Maxinoha';
{$ifdef DEBUG_HELPER} LDH('ParseXML(): zapis ciselniku do '+GetOfflineDir()+katalog+'_CiselnikyZKatalogu.txt'); {$endif}
    StringToFile(aCiselniky.Text,GetOfflineDir()+'Ciselniky_'+katalog+'.txt');
  finally
    aCiselniky.Free();
  end;
end;
